{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Test.Curry_Prop
  ( C_PropIO (..)
  , C_Test (..)
  , C_Result (..)
  , C_Prop (..)
  , d_C_returns
  , nd_C_returns
  , d_C_sameReturns
  , nd_C_sameReturns
  , d_C_toError
  , nd_C_toError
  , d_C_toIOError
  , nd_C_toIOError
  , d_OP_minus_eq_minus
  , d_OP_lt_tilde_gt
  , d_OP_tilde_gt
  , d_OP_lt_tilde
  , d_OP_lt_tilde_tilde_gt
  , d_OP_eq_eq_gt
  , nd_C_solutionOf
  , d_C_is
  , nd_C_is
  , d_C_isAlways
  , nd_C_isAlways
  , d_C_isEventually
  , nd_C_isEventually
  , d_C_uniquely
  , d_C_always
  , d_C_eventually
  , d_C_failing
  , d_C_successful
  , d_C_deterministic
  , d_OP_hash
  , d_OP_hash_lt
  , d_OP_hash_gt
  , d_C_for
  , nd_C_for
  , d_C_label
  , d_C_classify
  , d_C_trivial
  , d_C_collect
  , d_C_collectAs
  , d_C_valuesOf )
  where

import Basics
import qualified Curry_Prelude


data C_PropIO
  = C_PropIO (Curry_Prelude.C_Bool -> Cover -> ConstStore
    -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
    -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)))
  | HO_C_PropIO (Func Curry_Prelude.C_Bool (Func (Curry_Prelude.OP_List
    Curry_Prelude.C_Char) (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
    (Curry_Prelude.OP_List Curry_Prelude.C_Char)))))
  | Choice_C_PropIO Cover ID C_PropIO C_PropIO
  | Choices_C_PropIO Cover ID [C_PropIO]
  | Fail_C_PropIO Cover FailInfo
  | Guard_C_PropIO Cover Constraints C_PropIO

instance Show C_PropIO where
  showsPrec d (Choice_C_PropIO cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_PropIO cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_PropIO cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_PropIO cd info) = showChar '!'
  showsPrec _ (C_PropIO x1) = showString "(PropIO" . (showChar ' ' . (shows x1 .
    showChar ')'))
  showsPrec _ (HO_C_PropIO x1) = showString "(PropIO" . (showChar ' ' . (shows
    x1 . showChar ')'))

instance Read C_PropIO where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_PropIO x1, r1) | (_, r0) <-
    readQualified "Test.Prop" "PropIO" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_PropIO where
  choiceCons = Choice_C_PropIO
  choicesCons = Choices_C_PropIO
  failCons = Fail_C_PropIO
  guardCons = Guard_C_PropIO
  try (Choice_C_PropIO cd i x y) = tryChoice cd i x y
  try (Choices_C_PropIO cd i xs) = tryChoices cd i xs
  try (Fail_C_PropIO cd info) = Fail cd info
  try (Guard_C_PropIO cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_PropIO cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_PropIO cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_PropIO cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_PropIO cd i _) = error
    ("Test.Prop.PropIO.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_PropIO cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_PropIO cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_PropIO where
  generate s c = Choices_C_PropIO c (freeID [1] s) [HO_C_PropIO (generate
    (leftSupply s) c)]

instance NormalForm C_PropIO where
  ($!!) cont (C_PropIO x1) d cs = ($!!) (\y1 d cs -> cont (C_PropIO y1) d cs) x1
    d cs
  ($!!) cont (HO_C_PropIO x1) d cs = ($!!) (\y1 d cs -> cont (HO_C_PropIO y1) d
    cs) x1 d cs
  ($!!) cont (Choice_C_PropIO cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_PropIO cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_PropIO cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_PropIO cd info) _ _ = failCons cd info
  ($##) cont (C_PropIO x1) d cs = ($##) (\y1 d cs -> cont (C_PropIO y1) d cs) x1
    d cs
  ($##) cont (HO_C_PropIO x1) d cs = ($##) (\y1 d cs -> cont (HO_C_PropIO y1) d
    cs) x1 d cs
  ($##) cont (Choice_C_PropIO cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_PropIO cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_PropIO cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_PropIO cd info) _ _ = failCons cd info
  showCons (C_PropIO _) = "Test.Prop.PropIO _"
  showCons (HO_C_PropIO _) = "Test.Prop.PropIO _"
  showCons x = error ("Test.Prop.PropIO.showCons: no constructor: " ++ show x)
  searchNF search cont (C_PropIO x1) = search (\y1 -> cont (C_PropIO y1)) x1
  searchNF search cont (HO_C_PropIO x1) = search (\y1 -> cont (HO_C_PropIO y1))
    x1
  searchNF _ _ x = error ("Test.Prop.PropIO.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_PropIO where
  (=.=) (C_PropIO x1) (C_PropIO y1) d cs = (=:=) x1 y1 d cs
  (=.=) (HO_C_PropIO x1) (HO_C_PropIO y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_PropIO x1) (C_PropIO y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (HO_C_PropIO x1) (HO_C_PropIO y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_PropIO x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind cd i (HO_C_PropIO x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i)
    x3]
  bind d i (Choice_C_PropIO cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_PropIO cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_PropIO cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_PropIO cd i _) = error
    ("Test.Prop.PropIO.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_PropIO cd info) = [Unsolvable info]
  bind d i (Guard_C_PropIO cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_PropIO x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (HO_C_PropIO x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_PropIO cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_PropIO cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_PropIO cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_PropIO cd i _) = error
    ("Test.Prop.PropIO.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_PropIO cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_PropIO cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_PropIO where
  (=?=) (Choice_C_PropIO cd i x y) z d cs = narrow cd i ((=?=) x z d cs) ((=?=)
    y z d cs)
  (=?=) (Choices_C_PropIO cd i xs) y d cs = narrows cs cd i (\x -> (=?=) x y d
    cs) xs
  (=?=) (Guard_C_PropIO cd c e) y d cs = guardCons cd c ((=?=) e y d (addCs c
    cs))
  (=?=) (Fail_C_PropIO cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_PropIO cd i x y) d cs = narrow cd i ((=?=) z x d cs) ((=?=)
    z y d cs)
  (=?=) y (Choices_C_PropIO cd i xs) d cs = narrows cs cd i (\x -> (=?=) y x d
    cs) xs
  (=?=) y (Guard_C_PropIO cd c e) d cs = guardCons cd c ((=?=) y e d (addCs c
    cs))
  (=?=) _ (Fail_C_PropIO cd info) _ _ = failCons cd info
  (=?=) (C_PropIO x1) (C_PropIO y1) d cs = (=?=) x1 y1 d cs
  (=?=) (HO_C_PropIO x1) (HO_C_PropIO y1) d cs = (=?=) x1 y1 d cs
  (<?=) (Choice_C_PropIO cd i x y) z d cs = narrow cd i ((<?=) x z d cs) ((<?=)
    y z d cs)
  (<?=) (Choices_C_PropIO cd i xs) y d cs = narrows cs cd i (\x -> (<?=) x y d
    cs) xs
  (<?=) (Guard_C_PropIO cd c e) y d cs = guardCons cd c ((<?=) e y d (addCs c
    cs))
  (<?=) (Fail_C_PropIO cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_PropIO cd i x y) d cs = narrow cd i ((<?=) z x d cs) ((<?=)
    z y d cs)
  (<?=) y (Choices_C_PropIO cd i xs) d cs = narrows cs cd i (\x -> (<?=) y x d
    cs) xs
  (<?=) y (Guard_C_PropIO cd c e) d cs = guardCons cd c ((<?=) y e d (addCs c
    cs))
  (<?=) _ (Fail_C_PropIO cd info) _ _ = failCons cd info
  (<?=) (C_PropIO x1) (C_PropIO y1) d cs = (<?=) x1 y1 d cs
  (<?=) (HO_C_PropIO x1) (HO_C_PropIO y1) d cs = (<?=) x1 y1 d cs

data C_Test
  = C_Test C_Result (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))
  | Choice_C_Test Cover ID C_Test C_Test
  | Choices_C_Test Cover ID [C_Test]
  | Fail_C_Test Cover FailInfo
  | Guard_C_Test Cover Constraints C_Test

instance Show C_Test where
  showsPrec d (Choice_C_Test cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Test cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Test cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Test cd info) = showChar '!'
  showsPrec _ (C_Test x1 x2 x3) = showString "(Test" . (showChar ' ' . (shows
    x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 . showChar
    ')'))))))

instance Read C_Test where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Test x1 x2 x3, r3) | (_, r0)
    <- readQualified "Test.Prop" "Test" r, (x1, r1) <- readsPrec 11 r0, (x2, r2)
    <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2]) s

instance NonDet C_Test where
  choiceCons = Choice_C_Test
  choicesCons = Choices_C_Test
  failCons = Fail_C_Test
  guardCons = Guard_C_Test
  try (Choice_C_Test cd i x y) = tryChoice cd i x y
  try (Choices_C_Test cd i xs) = tryChoices cd i xs
  try (Fail_C_Test cd info) = Fail cd info
  try (Guard_C_Test cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Test cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Test cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Test cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Test cd i _) = error
    ("Test.Prop.Test.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Test cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Test cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Test where
  generate s c = Choices_C_Test c (freeID [3] s) [C_Test (generate (leftSupply
    (leftSupply s)) c) (generate (rightSupply (leftSupply s)) c) (generate
    (rightSupply s) c)]

instance NormalForm C_Test where
  ($!!) cont (C_Test x1 x2 x3) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> cont (C_Test y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Test cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Test cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Test cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Test cd info) _ _ = failCons cd info
  ($##) cont (C_Test x1 x2 x3) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> cont (C_Test y1 y2 y3) d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Test cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Test cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Test cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Test cd info) _ _ = failCons cd info
  showCons (C_Test _ _ _) = "Test.Prop.Test _ _ _"
  showCons x = error ("Test.Prop.Test.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Test x1 x2 x3) = search (\y1 -> search (\y2 -> search
    (\y3 -> cont (C_Test y1 y2 y3)) x3) x2) x1
  searchNF _ _ x = error ("Test.Prop.Test.searchNF: no constructor: " ++ show x)

instance Unifiable C_Test where
  (=.=) (C_Test x1 x2 x3) (C_Test y1 y2 y3) d cs = (&) ((=:=) x1 y1 d cs) ((&)
    ((=:=) x2 y2 d cs) ((=:=) x3 y3 d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Test x1 x2 x3) (C_Test y1 y2 y3) d cs = (&) ((=:<=) x1 y1 d cs) ((&)
    ((=:<=) x2 y2 d cs) ((=:<=) x3 y3 d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Test x3 x4 x5) = (i :=: ChooseN 0 3) : concat [bind cd (leftID
    (leftID i)) x3, bind cd (rightID (leftID i)) x4, bind cd (rightID i) x5]
  bind d i (Choice_C_Test cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Test cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Test cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Test cd i _) = error
    ("Test.Prop.Test.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Test cd info) = [Unsolvable info]
  bind d i (Guard_C_Test cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Test x3 x4 x5) = (i :=: ChooseN 0 3) : [leftID (leftID i) :=:
    LazyBind (lazyBind cd (leftID (leftID i)) x3), rightID (leftID i) :=:
    LazyBind (lazyBind cd (rightID (leftID i)) x4), rightID i :=: LazyBind
    (lazyBind cd (rightID i) x5)]
  lazyBind d i (Choice_C_Test cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Test cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Test cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Test cd i _) = error
    ("Test.Prop.Test.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Test cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Test cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Test where
  (=?=) (Choice_C_Test cd i x y) z d cs = narrow cd i ((=?=) x z d cs) ((=?=) y
    z d cs)
  (=?=) (Choices_C_Test cd i xs) y d cs = narrows cs cd i (\x -> (=?=) x y d cs)
    xs
  (=?=) (Guard_C_Test cd c e) y d cs = guardCons cd c ((=?=) e y d (addCs c cs))
  (=?=) (Fail_C_Test cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_Test cd i x y) d cs = narrow cd i ((=?=) z x d cs) ((=?=) z
    y d cs)
  (=?=) y (Choices_C_Test cd i xs) d cs = narrows cs cd i (\x -> (=?=) y x d cs)
    xs
  (=?=) y (Guard_C_Test cd c e) d cs = guardCons cd c ((=?=) y e d (addCs c cs))
  (=?=) _ (Fail_C_Test cd info) _ _ = failCons cd info
  (=?=) (C_Test x1 x2 x3) (C_Test y1 y2 y3) d cs = Curry_Prelude.d_OP_amp_amp
    ((=?=) x1 y1 d cs) (Curry_Prelude.d_OP_amp_amp ((=?=) x2 y2 d cs) ((=?=) x3
    y3 d cs) d cs) d cs
  (<?=) (Choice_C_Test cd i x y) z d cs = narrow cd i ((<?=) x z d cs) ((<?=) y
    z d cs)
  (<?=) (Choices_C_Test cd i xs) y d cs = narrows cs cd i (\x -> (<?=) x y d cs)
    xs
  (<?=) (Guard_C_Test cd c e) y d cs = guardCons cd c ((<?=) e y d (addCs c cs))
  (<?=) (Fail_C_Test cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_Test cd i x y) d cs = narrow cd i ((<?=) z x d cs) ((<?=) z
    y d cs)
  (<?=) y (Choices_C_Test cd i xs) d cs = narrows cs cd i (\x -> (<?=) y x d cs)
    xs
  (<?=) y (Guard_C_Test cd c e) d cs = guardCons cd c ((<?=) y e d (addCs c cs))
  (<?=) _ (Fail_C_Test cd info) _ _ = failCons cd info
  (<?=) (C_Test x1 x2 x3) (C_Test y1 y2 y3) d cs = Curry_Prelude.d_OP_bar_bar
    (Curry_Prelude.d_OP_lt x1 y1 d cs) (Curry_Prelude.d_OP_amp_amp ((=?=) x1 y1
    d cs) (Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_lt x2 y2 d cs)
    (Curry_Prelude.d_OP_amp_amp ((=?=) x2 y2 d cs) ((<?=) x3 y3 d cs) d cs) d
    cs) d cs) d cs

data C_Result
  = C_Undef
  | C_Ok
  | C_Falsified (Curry_Prelude.OP_List (Curry_Prelude.OP_List
    Curry_Prelude.C_Char))
  | C_Ambigious (Curry_Prelude.OP_List Curry_Prelude.C_Bool)
    (Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char))
  | Choice_C_Result Cover ID C_Result C_Result
  | Choices_C_Result Cover ID [C_Result]
  | Fail_C_Result Cover FailInfo
  | Guard_C_Result Cover Constraints C_Result

instance Show C_Result where
  showsPrec d (Choice_C_Result cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Result cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Result cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Result cd info) = showChar '!'
  showsPrec _ C_Undef = showString "Undef"
  showsPrec _ C_Ok = showString "Ok"
  showsPrec _ (C_Falsified x1) = showString "(Falsified" . (showChar ' ' .
    (shows x1 . showChar ')'))
  showsPrec _ (C_Ambigious x1 x2) = showString "(Ambigious" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . showChar ')'))))

instance Read C_Result where
  readsPrec d s = readParen False (\r -> [(C_Undef, r0) | (_, r0) <-
    readQualified "Test.Prop" "Undef" r]) s ++ (readParen False (\r -> [(C_Ok
    , r0) | (_, r0) <- readQualified "Test.Prop" "Ok" r]) s ++ (readParen ((>) d
    10) (\r -> [(C_Falsified x1, r1) | (_, r0) <- readQualified "Test.Prop"
    "Falsified" r, (x1, r1) <- readsPrec 11 r0]) s ++ readParen ((>) d 10)
    (\r -> [(C_Ambigious x1 x2, r2) | (_, r0) <- readQualified "Test.Prop"
    "Ambigious" r, (x1, r1) <- readsPrec 11 r0, (x2, r2) <- readsPrec 11 r1])
    s))

instance NonDet C_Result where
  choiceCons = Choice_C_Result
  choicesCons = Choices_C_Result
  failCons = Fail_C_Result
  guardCons = Guard_C_Result
  try (Choice_C_Result cd i x y) = tryChoice cd i x y
  try (Choices_C_Result cd i xs) = tryChoices cd i xs
  try (Fail_C_Result cd info) = Fail cd info
  try (Guard_C_Result cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Result cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Result cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Result cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Result cd i _) = error
    ("Test.Prop.Result.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Result cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Result cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Result where
  generate s c = Choices_C_Result c (freeID [0, 0, 1, 2] s) [C_Undef, C_Ok
    , C_Falsified (generate (leftSupply s) c), C_Ambigious (generate (leftSupply
    s) c) (generate (rightSupply s) c)]

instance NormalForm C_Result where
  ($!!) cont C_Undef d cs = cont C_Undef d cs
  ($!!) cont C_Ok d cs = cont C_Ok d cs
  ($!!) cont (C_Falsified x1) d cs = ($!!) (\y1 d cs -> cont (C_Falsified y1) d
    cs) x1 d cs
  ($!!) cont (C_Ambigious x1 x2) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    cont (C_Ambigious y1 y2) d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Result cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Result cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Result cd c e) d cs = guardCons cd c (($!!) cont e d
    (addCs c cs))
  ($!!) _ (Fail_C_Result cd info) _ _ = failCons cd info
  ($##) cont C_Undef d cs = cont C_Undef d cs
  ($##) cont C_Ok d cs = cont C_Ok d cs
  ($##) cont (C_Falsified x1) d cs = ($##) (\y1 d cs -> cont (C_Falsified y1) d
    cs) x1 d cs
  ($##) cont (C_Ambigious x1 x2) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    cont (C_Ambigious y1 y2) d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Result cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Result cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Result cd c e) d cs = guardCons cd c (($##) cont e d
    (addCs c cs))
  ($##) _ (Fail_C_Result cd info) _ _ = failCons cd info
  showCons C_Undef = "Test.Prop.Undef"
  showCons C_Ok = "Test.Prop.Ok"
  showCons (C_Falsified _) = "Test.Prop.Falsified _"
  showCons (C_Ambigious _ _) = "Test.Prop.Ambigious _ _"
  showCons x = error ("Test.Prop.Result.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Undef = cont C_Undef
  searchNF _ cont C_Ok = cont C_Ok
  searchNF search cont (C_Falsified x1) = search (\y1 -> cont (C_Falsified y1))
    x1
  searchNF search cont (C_Ambigious x1 x2) = search (\y1 -> search (\y2 -> cont
    (C_Ambigious y1 y2)) x2) x1
  searchNF _ _ x = error ("Test.Prop.Result.searchNF: no constructor: " ++ show
    x)

instance Unifiable C_Result where
  (=.=) C_Undef C_Undef d cs = C_True
  (=.=) C_Ok C_Ok d cs = C_True
  (=.=) (C_Falsified x1) (C_Falsified y1) d cs = (=:=) x1 y1 d cs
  (=.=) (C_Ambigious x1 x2) (C_Ambigious y1 y2) d cs = (&) ((=:=) x1 y1 d cs)
    ((=:=) x2 y2 d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Undef C_Undef d cs = C_True
  (=.<=) C_Ok C_Ok d cs = C_True
  (=.<=) (C_Falsified x1) (C_Falsified y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) (C_Ambigious x1 x2) (C_Ambigious y1 y2) d cs = (&) ((=:<=) x1 y1 d cs)
    ((=:<=) x2 y2 d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Undef = (i :=: ChooseN 0 0) : concat []
  bind cd i C_Ok = (i :=: ChooseN 1 0) : concat []
  bind cd i (C_Falsified x3) = (i :=: ChooseN 2 1) : concat [bind cd (leftID i)
    x3]
  bind cd i (C_Ambigious x3 x4) = (i :=: ChooseN 3 2) : concat [bind cd (leftID
    i) x3, bind cd (rightID i) x4]
  bind d i (Choice_C_Result cd j x y) = [ConstraintChoice cd j (bind d i x)
    (bind d i y)]
  bind d i (Choices_C_Result cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Result cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Result cd i _) = error
    ("Test.Prop.Result.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Result cd info) = [Unsolvable info]
  bind d i (Guard_C_Result cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Undef = (i :=: ChooseN 0 0) : []
  lazyBind cd i C_Ok = (i :=: ChooseN 1 0) : []
  lazyBind cd i (C_Falsified x3) = (i :=: ChooseN 2 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind cd i (C_Ambigious x3 x4) = (i :=: ChooseN 3 2) : [leftID i :=:
    LazyBind (lazyBind cd (leftID i) x3), rightID i :=: LazyBind (lazyBind cd
    (rightID i) x4)]
  lazyBind d i (Choice_C_Result cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Result cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd
    j xs
  lazyBind d i (Choices_C_Result cd j@(NarrowedID _ _) xs) = [ConstraintChoices
    cd j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Result cd i _) = error
    ("Test.Prop.Result.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Result cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Result cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Result where
  (=?=) (Choice_C_Result cd i x y) z d cs = narrow cd i ((=?=) x z d cs) ((=?=)
    y z d cs)
  (=?=) (Choices_C_Result cd i xs) y d cs = narrows cs cd i (\x -> (=?=) x y d
    cs) xs
  (=?=) (Guard_C_Result cd c e) y d cs = guardCons cd c ((=?=) e y d (addCs c
    cs))
  (=?=) (Fail_C_Result cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_Result cd i x y) d cs = narrow cd i ((=?=) z x d cs) ((=?=)
    z y d cs)
  (=?=) y (Choices_C_Result cd i xs) d cs = narrows cs cd i (\x -> (=?=) y x d
    cs) xs
  (=?=) y (Guard_C_Result cd c e) d cs = guardCons cd c ((=?=) y e d (addCs c
    cs))
  (=?=) _ (Fail_C_Result cd info) _ _ = failCons cd info
  (=?=) C_Undef C_Undef d cs = C_True
  (=?=) C_Ok C_Ok d cs = C_True
  (=?=) (C_Falsified x1) (C_Falsified y1) d cs = (=?=) x1 y1 d cs
  (=?=) (C_Ambigious x1 x2) (C_Ambigious y1 y2) d cs =
    Curry_Prelude.d_OP_amp_amp ((=?=) x1 y1 d cs) ((=?=) x2 y2 d cs) d cs
  (=?=) _ _ d _ = C_False
  (<?=) (Choice_C_Result cd i x y) z d cs = narrow cd i ((<?=) x z d cs) ((<?=)
    y z d cs)
  (<?=) (Choices_C_Result cd i xs) y d cs = narrows cs cd i (\x -> (<?=) x y d
    cs) xs
  (<?=) (Guard_C_Result cd c e) y d cs = guardCons cd c ((<?=) e y d (addCs c
    cs))
  (<?=) (Fail_C_Result cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_Result cd i x y) d cs = narrow cd i ((<?=) z x d cs) ((<?=)
    z y d cs)
  (<?=) y (Choices_C_Result cd i xs) d cs = narrows cs cd i (\x -> (<?=) y x d
    cs) xs
  (<?=) y (Guard_C_Result cd c e) d cs = guardCons cd c ((<?=) y e d (addCs c
    cs))
  (<?=) _ (Fail_C_Result cd info) _ _ = failCons cd info
  (<?=) C_Undef C_Undef d cs = C_True
  (<?=) C_Undef C_Ok _ _ = C_True
  (<?=) C_Undef (C_Falsified _) _ _ = C_True
  (<?=) C_Undef (C_Ambigious _ _) _ _ = C_True
  (<?=) C_Ok C_Ok d cs = C_True
  (<?=) C_Ok (C_Falsified _) _ _ = C_True
  (<?=) C_Ok (C_Ambigious _ _) _ _ = C_True
  (<?=) (C_Falsified x1) (C_Falsified y1) d cs = (<?=) x1 y1 d cs
  (<?=) (C_Falsified _) (C_Ambigious _ _) _ _ = C_True
  (<?=) (C_Ambigious x1 x2) (C_Ambigious y1 y2) d cs =
    Curry_Prelude.d_OP_bar_bar (Curry_Prelude.d_OP_lt x1 y1 d cs)
    (Curry_Prelude.d_OP_amp_amp ((=?=) x1 y1 d cs) ((<?=) x2 y2 d cs) d cs) d cs
  (<?=) _ _ d _ = C_False

data C_Prop
  = C_Prop (Curry_Prelude.OP_List C_Test)
  | Choice_C_Prop Cover ID C_Prop C_Prop
  | Choices_C_Prop Cover ID [C_Prop]
  | Fail_C_Prop Cover FailInfo
  | Guard_C_Prop Cover Constraints C_Prop

instance Show C_Prop where
  showsPrec d (Choice_C_Prop cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Prop cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Prop cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Prop cd info) = showChar '!'
  showsPrec _ (C_Prop x1) = showString "(Prop" . (showChar ' ' . (shows x1 .
    showChar ')'))

instance Read C_Prop where
  readsPrec d s = readParen ((>) d 10) (\r -> [(C_Prop x1, r1) | (_, r0) <-
    readQualified "Test.Prop" "Prop" r, (x1, r1) <- readsPrec 11 r0]) s

instance NonDet C_Prop where
  choiceCons = Choice_C_Prop
  choicesCons = Choices_C_Prop
  failCons = Fail_C_Prop
  guardCons = Guard_C_Prop
  try (Choice_C_Prop cd i x y) = tryChoice cd i x y
  try (Choices_C_Prop cd i xs) = tryChoices cd i xs
  try (Fail_C_Prop cd info) = Fail cd info
  try (Guard_C_Prop cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Prop cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Prop cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Prop cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Prop cd i _) = error
    ("Test.Prop.Prop.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Prop cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Prop cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance Generable C_Prop where
  generate s c = Choices_C_Prop c (freeID [1] s) [C_Prop (generate (leftSupply
    s) c)]

instance NormalForm C_Prop where
  ($!!) cont (C_Prop x1) d cs = ($!!) (\y1 d cs -> cont (C_Prop y1) d cs) x1 d
    cs
  ($!!) cont (Choice_C_Prop cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Prop cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Prop cd c e) d cs = guardCons cd c (($!!) cont e d (addCs
    c cs))
  ($!!) _ (Fail_C_Prop cd info) _ _ = failCons cd info
  ($##) cont (C_Prop x1) d cs = ($##) (\y1 d cs -> cont (C_Prop y1) d cs) x1 d
    cs
  ($##) cont (Choice_C_Prop cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Prop cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Prop cd c e) d cs = guardCons cd c (($##) cont e d (addCs
    c cs))
  ($##) _ (Fail_C_Prop cd info) _ _ = failCons cd info
  showCons (C_Prop _) = "Test.Prop.Prop _"
  showCons x = error ("Test.Prop.Prop.showCons: no constructor: " ++ show x)
  searchNF search cont (C_Prop x1) = search (\y1 -> cont (C_Prop y1)) x1
  searchNF _ _ x = error ("Test.Prop.Prop.searchNF: no constructor: " ++ show x)

instance Unifiable C_Prop where
  (=.=) (C_Prop x1) (C_Prop y1) d cs = (=:=) x1 y1 d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) (C_Prop x1) (C_Prop y1) d cs = (=:<=) x1 y1 d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i (C_Prop x3) = (i :=: ChooseN 0 1) : concat [bind cd (leftID i) x3]
  bind d i (Choice_C_Prop cd j x y) = [ConstraintChoice cd j (bind d i x) (bind
    d i y)]
  bind d i (Choices_C_Prop cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Prop cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Prop cd i _) = error
    ("Test.Prop.Prop.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Prop cd info) = [Unsolvable info]
  bind d i (Guard_C_Prop cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i (C_Prop x3) = (i :=: ChooseN 0 1) : [leftID i :=: LazyBind
    (lazyBind cd (leftID i) x3)]
  lazyBind d i (Choice_C_Prop cd j x y) = [ConstraintChoice cd j (lazyBind d i
    x) (lazyBind d i y)]
  lazyBind d i (Choices_C_Prop cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Prop cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Prop cd i _) = error
    ("Test.Prop.Prop.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Prop cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Prop cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance Curry C_Prop where
  (=?=) (Choice_C_Prop cd i x y) z d cs = narrow cd i ((=?=) x z d cs) ((=?=) y
    z d cs)
  (=?=) (Choices_C_Prop cd i xs) y d cs = narrows cs cd i (\x -> (=?=) x y d cs)
    xs
  (=?=) (Guard_C_Prop cd c e) y d cs = guardCons cd c ((=?=) e y d (addCs c cs))
  (=?=) (Fail_C_Prop cd info) _ _ _ = failCons cd info
  (=?=) z (Choice_C_Prop cd i x y) d cs = narrow cd i ((=?=) z x d cs) ((=?=) z
    y d cs)
  (=?=) y (Choices_C_Prop cd i xs) d cs = narrows cs cd i (\x -> (=?=) y x d cs)
    xs
  (=?=) y (Guard_C_Prop cd c e) d cs = guardCons cd c ((=?=) y e d (addCs c cs))
  (=?=) _ (Fail_C_Prop cd info) _ _ = failCons cd info
  (=?=) (C_Prop x1) (C_Prop y1) d cs = (=?=) x1 y1 d cs
  (<?=) (Choice_C_Prop cd i x y) z d cs = narrow cd i ((<?=) x z d cs) ((<?=) y
    z d cs)
  (<?=) (Choices_C_Prop cd i xs) y d cs = narrows cs cd i (\x -> (<?=) x y d cs)
    xs
  (<?=) (Guard_C_Prop cd c e) y d cs = guardCons cd c ((<?=) e y d (addCs c cs))
  (<?=) (Fail_C_Prop cd info) _ _ _ = failCons cd info
  (<?=) z (Choice_C_Prop cd i x y) d cs = narrow cd i ((<?=) z x d cs) ((<?=) z
    y d cs)
  (<?=) y (Choices_C_Prop cd i xs) d cs = narrows cs cd i (\x -> (<?=) y x d cs)
    xs
  (<?=) y (Guard_C_Prop cd c e) d cs = guardCons cd c ((<?=) y e d (addCs c cs))
  (<?=) _ (Fail_C_Prop cd info) _ _ = failCons cd info
  (<?=) (C_Prop x1) (C_Prop y1) d cs = (<?=) x1 y1 d cs

d_C_returns :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> t0 -> Cover -> ConstStore -> C_PropIO
d_C_returns x1 x2 cd cs = C_PropIO (acceptCs id (d_C_testIO x1
  (Curry_Prelude.d_C_return x2 cd cs)))

nd_C_returns :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> t0 -> IDSupply -> Cover -> ConstStore -> C_PropIO
nd_C_returns x1 x2 s cd cs = HO_C_PropIO (wrapDX (wrapNX id) (acceptCs id
  (nd_C_testIO x1 (Curry_Prelude.d_C_return x2 cd cs))))

d_C_sameReturns :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Curry_Prelude.C_IO t0 -> Cover -> ConstStore -> C_PropIO
d_C_sameReturns x1 x2 cd cs = C_PropIO (acceptCs id (d_C_testIO x1 x2))

nd_C_sameReturns :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO
  t0 -> Curry_Prelude.C_IO t0 -> IDSupply -> Cover -> ConstStore -> C_PropIO
nd_C_sameReturns x1 x2 s cd cs = HO_C_PropIO (wrapDX (wrapNX id) (acceptCs id
  (nd_C_testIO x1 x2)))

d_C_toError :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> C_PropIO
d_C_toError x1 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "toError") cd cs

nd_C_toError :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> IDSupply -> Cover
  -> ConstStore -> C_PropIO
nd_C_toError x1 s cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "toError") cd cs

d_C_toIOError :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Cover -> ConstStore -> C_PropIO
d_C_toIOError x1 cd cs = C_PropIO (acceptCs id (d_C_hasIOError x1))

nd_C_toIOError :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> IDSupply -> Cover -> ConstStore -> C_PropIO
nd_C_toIOError x1 s cd cs = HO_C_PropIO (wrapDX (wrapNX id) (acceptCs id
  (nd_C_hasIOError x1)))

d_C_ioTestOf :: C_PropIO -> Cover -> ConstStore -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_ioTestOf x1 cd cs = case x1 of
  C_PropIO x2 -> x2
  Choice_C_PropIO d i l r -> narrow d i (d_C_ioTestOf l cd cs) (d_C_ioTestOf r
    cd cs)
  Choices_C_PropIO d i xs -> narrows cs d i (\z -> d_C_ioTestOf z cd cs) xs
  Guard_C_PropIO d c e -> guardCons d c (d_C_ioTestOf e cd $! addCs c cs)
  Fail_C_PropIO d info -> failCons d (traceFail "Test.Prop.ioTestOf" [show x1]
    info)
  _ -> failCons cd (consFail "Test.Prop.ioTestOf" (showCons x1))

nd_C_ioTestOf :: C_PropIO -> IDSupply -> Cover -> ConstStore -> Func
  Curry_Prelude.C_Bool (Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))))
nd_C_ioTestOf x1 s cd cs = case x1 of
  HO_C_PropIO x2 -> x2
  Choice_C_PropIO d i l r -> narrow d i (nd_C_ioTestOf l s cd cs) (nd_C_ioTestOf
    r s cd cs)
  Choices_C_PropIO d i xs -> narrows cs d i (\z -> nd_C_ioTestOf z s cd cs) xs
  Guard_C_PropIO d c e -> guardCons d c (nd_C_ioTestOf e s cd $! addCs c cs)
  Fail_C_PropIO d info -> failCons d (traceFail "Test.Prop.ioTestOf" [show x1]
    info)
  _ -> failCons cd (consFail "Test.Prop.ioTestOf" (showCons x1))

d_C_testIO :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Curry_Prelude.C_IO t0 -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_testIO x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_catch
  (Curry_Prelude.d_OP_gt_gt_eq x1 (d_OP_testIO_dot_uscore_hash_lambda1 x2 x4 x3)
  cd cs) (d_OP_testIO_dot_uscore_hash_lambda3 x4) cd cs

nd_C_testIO :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Curry_Prelude.C_IO t0 -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_testIO x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_catch (Curry_Prelude.nd_OP_gt_gt_eq
  x1 (wrapNX id (nd_OP_testIO_dot_uscore_hash_lambda1 x2 x4 x3)) s0 cd cs)
  (wrapDX id (d_OP_testIO_dot_uscore_hash_lambda3 x4)) s1 cd cs))

d_OP_testIO_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_testIO_dot_uscore_hash_lambda1 x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_gt_gt_eq x1
  (d_OP_testIO_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x2 x3 x4) cd cs

nd_OP_testIO_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_IO t0 -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_testIO_dot_uscore_hash_lambda1 x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_gt_gt_eq x1 (wrapDX id
  (d_OP_testIO_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x2 x3 x4)) s0 cd
  cs

d_OP_testIO_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_testIO_dot_uscore_hash_lambda1_dot_uscore_hash_lambda2 x1 x2 x3 x4 cd cs =
  d_C__case_6 x4 x3 x1 x2 (Curry_Prelude.d_OP_eq_eq x3 x4 cd cs) cd cs

d_OP_testIO_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_IOError -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_testIO_dot_uscore_hash_lambda3 x1 x2 cd cs = Curry_Prelude.d_OP_gt_gt
  (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_putStrLn
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString ": EXECUTION FAILURE:\n")
  (Curry_Prelude.d_C_showError x2 cd cs) cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x1) cd cs) cd cs

d_C_hasIOError :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C_hasIOError x1 x2 x3 cd cs = Curry_Prelude.d_C_catch
  (Curry_Prelude.d_OP_gt_gt x1 (Curry_Prelude.d_C_return (Curry_Prelude.C_Just
  x3) cd cs) cd cs) (d_OP_hasIOError_dot_uscore_hash_lambda4 x3 x2) cd cs

nd_C_hasIOError :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_IO t0
  -> Curry_Prelude.C_Bool -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C_hasIOError x1 x2 x3 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_catch (Curry_Prelude.nd_OP_gt_gt x1
  (Curry_Prelude.d_C_return (Curry_Prelude.C_Just x3) cd cs) s0 cd cs) (wrapDX
  id (d_OP_hasIOError_dot_uscore_hash_lambda4 x3 x2)) s1 cd cs))

d_OP_hasIOError_dot_uscore_hash_lambda4 :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_IOError -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe t0)
d_OP_hasIOError_dot_uscore_hash_lambda4 x1 x2 x3 cd cs =
  Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_unless x2
  (Curry_Prelude.d_C_putStr (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString ": OK\n") cd cs) cd cs) cd cs)
  (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) cd cs

d_C_testsOf :: C_Prop -> Cover -> ConstStore -> Curry_Prelude.OP_List C_Test
d_C_testsOf x1 cd cs = case x1 of
  C_Prop x2 -> x2
  Choice_C_Prop d i l r -> narrow d i (d_C_testsOf l cd cs) (d_C_testsOf r cd
    cs)
  Choices_C_Prop d i xs -> narrows cs d i (\z -> d_C_testsOf z cd cs) xs
  Guard_C_Prop d c e -> guardCons d c (d_C_testsOf e cd $! addCs c cs)
  Fail_C_Prop d info -> failCons d (traceFail "Test.Prop.testsOf" [show x1]
    info)
  _ -> failCons cd (consFail "Test.Prop.testsOf" (showCons x1))

d_C_notest :: Cover -> ConstStore -> C_Test
d_C_notest cd cs = C_Test C_Undef Curry_Prelude.OP_List Curry_Prelude.OP_List

d_C_result :: C_Test -> Cover -> ConstStore -> C_Result
d_C_result x1 cd cs = case x1 of
  C_Test x2 x3 x4 -> x2
  Choice_C_Test d i l r -> narrow d i (d_C_result l cd cs) (d_C_result r cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_result z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_result e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.result" [show x1] info)
  _ -> failCons cd (consFail "Test.Prop.result" (showCons x1))

d_C_setResult :: C_Result -> C_Test -> Cover -> ConstStore -> C_Test
d_C_setResult x1 x2 cd cs = case x2 of
  C_Test x3 x4 x5 -> C_Test x1 x5 x4
  Choice_C_Test d i l r -> narrow d i (d_C_setResult x1 l cd cs) (d_C_setResult
    x1 r cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_setResult x1 z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_setResult x1 e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.setResult" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Test.Prop.setResult" (showCons x2))

d_C_args :: C_Test -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_args x1 cd cs = case x1 of
  C_Test x2 x3 x4 -> x3
  Choice_C_Test d i l r -> narrow d i (d_C_args l cd cs) (d_C_args r cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_args z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_args e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.args" [show x1] info)
  _ -> failCons cd (consFail "Test.Prop.args" (showCons x1))

d_C_stamp :: C_Test -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_stamp x1 cd cs = case x1 of
  C_Test x2 x3 x4 -> x4
  Choice_C_Test d i l r -> narrow d i (d_C_stamp l cd cs) (d_C_stamp r cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_stamp z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_stamp e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.stamp" [show x1] info)
  _ -> failCons cd (consFail "Test.Prop.stamp" (showCons x1))

d_C_updArgs :: (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_Test -> Cover -> ConstStore
  -> C_Test
d_C_updArgs x1 x2 cd cs = case x2 of
  C_Test x3 x4 x5 -> C_Test x3 (Curry_Prelude.d_C_apply x1 x4 cd cs) x5
  Choice_C_Test d i l r -> narrow d i (d_C_updArgs x1 l cd cs) (d_C_updArgs x1 r
    cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_updArgs x1 z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_updArgs x1 e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.updArgs" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Test.Prop.updArgs" (showCons x2))

nd_C_updArgs :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> C_Test -> IDSupply -> Cover -> ConstStore -> C_Test
nd_C_updArgs x1 x2 s cd cs = case x2 of
  C_Test x3 x4 x5 -> let s0 = s
    in s0 `seq` C_Test x3 (Curry_Prelude.nd_C_apply x1 x4 s0 cd cs) x5
  Choice_C_Test d i l r -> narrow d i (nd_C_updArgs x1 l s cd cs) (nd_C_updArgs
    x1 r s cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> nd_C_updArgs x1 z s cd cs) xs
  Guard_C_Test d c e -> guardCons d c (nd_C_updArgs x1 e s cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.updArgs" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Test.Prop.updArgs" (showCons x2))

d_C_updStamp :: (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> C_Test -> Cover -> ConstStore
  -> C_Test
d_C_updStamp x1 x2 cd cs = case x2 of
  C_Test x3 x4 x5 -> C_Test x3 x4 (Curry_Prelude.d_C_apply x1 x5 cd cs)
  Choice_C_Test d i l r -> narrow d i (d_C_updStamp x1 l cd cs) (d_C_updStamp x1
    r cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> d_C_updStamp x1 z cd cs) xs
  Guard_C_Test d c e -> guardCons d c (d_C_updStamp x1 e cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.updStamp" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Test.Prop.updStamp" (showCons x2))

nd_C_updStamp :: Func (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) (Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> C_Test -> IDSupply -> Cover -> ConstStore -> C_Test
nd_C_updStamp x1 x2 s cd cs = case x2 of
  C_Test x3 x4 x5 -> let s0 = s
    in s0 `seq` C_Test x3 x4 (Curry_Prelude.nd_C_apply x1 x5 s0 cd cs)
  Choice_C_Test d i l r -> narrow d i (nd_C_updStamp x1 l s cd cs)
    (nd_C_updStamp x1 r s cd cs)
  Choices_C_Test d i xs -> narrows cs d i (\z -> nd_C_updStamp x1 z s cd cs) xs
  Guard_C_Test d c e -> guardCons d c (nd_C_updStamp x1 e s cd $! addCs c cs)
  Fail_C_Test d info -> failCons d (traceFail "Test.Prop.updStamp" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Test.Prop.updStamp" (showCons x2))

d_C_test :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (Curry_Prelude.OP_List
  t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> C_Prop
d_C_test x1 x2 cd cs = let x3 = Curry_Prelude.d_C_apply (d_C_valuesOf cd cs) x1
                             cd cs
                           x4 = let x5 = Curry_Prelude.d_C_apply (d_C_valuesOf
                                      cd cs) (Curry_Prelude.d_C_apply x2 x3 cd
                                      cs) cd cs
                             in d_C__case_5 x3 x5 cd cs
  in C_Prop (Curry_Prelude.OP_Cons (d_C_setResult x4 (d_C_notest cd cs) cd cs)
  Curry_Prelude.OP_List)

nd_C_test :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func
  (Curry_Prelude.OP_List t0) Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_Prop
nd_C_test x1 x2 s cd cs = let s4 = s
  in s4 `seq` (let s0 = leftSupply s4
                   s3 = rightSupply s4
  in s0 `seq` (s3 `seq` (let x3 = Curry_Prelude.nd_C_apply (wrapDX id
                               (d_C_valuesOf cd cs)) x1 s0 cd cs
                             x4 = let x5 = let s2 = leftSupply s3
                                               s1 = rightSupply s3
                                        in s2 `seq` (s1 `seq`
                                        Curry_Prelude.nd_C_apply (wrapDX id
                                        (d_C_valuesOf cd cs))
                                        (Curry_Prelude.nd_C_apply x2 x3 s1 cd
                                        cs) s2 cd cs)
                               in d_C__case_5 x3 x5 cd cs
  in C_Prop (Curry_Prelude.OP_Cons (d_C_setResult x4 (d_C_notest cd cs) cd cs)
  Curry_Prelude.OP_List))))

d_OP_minus_eq_minus :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> C_Prop
d_OP_minus_eq_minus x1 x2 cd cs = d_C_is (Curry_Prelude.OP_Tuple2 x1 x2)
  (Curry_Prelude.d_C_uncurry (acceptCs id Curry_Prelude.d_OP_eq_eq)) cd cs

d_OP_lt_tilde_gt :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> C_Prop
d_OP_lt_tilde_gt x1 x2 cd cs = d_C_propUndefinedError
  (Curry_Prelude.toCurryString "<~>") cd cs

d_OP_tilde_gt :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> C_Prop
d_OP_tilde_gt x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "~>") cd cs

d_OP_lt_tilde :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0 -> Cover
  -> ConstStore -> C_Prop
d_OP_lt_tilde x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "<~") cd cs

d_OP_lt_tilde_tilde_gt :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> Cover -> ConstStore -> C_Prop
d_OP_lt_tilde_tilde_gt x1 x2 cd cs = d_C_propUndefinedError
  (Curry_Prelude.toCurryString "<~~>") cd cs

d_OP_eq_eq_gt :: Curry_Prelude.C_Bool -> C_Prop -> Cover -> ConstStore -> C_Prop
d_OP_eq_eq_gt x1 x2 cd cs = d_C__case_1 x1 x2 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_elem Curry_Prelude.C_True cd cs) (Curry_Prelude.d_C_apply
  (d_C_valuesOf cd cs) x1 cd cs) cd cs) cd cs

nd_C_solutionOf :: forall t0 . (Curry_Prelude.Curry t0) => Func t0
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> t0
nd_C_solutionOf x1 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` (let x2 = generate s0 cd
  in Curry_Prelude.d_OP_amp_gt (Curry_Prelude.nd_C_apply x1 x2 s1 cd cs) x2 cd
  cs)))

d_C_is :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> C_Prop
d_C_is x1 x2 cd cs = d_C_test x1 (d_OP_is_dot_uscore_hash_lambda6 x2) cd cs

nd_C_is :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Prop
nd_C_is x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C_test x1 (wrapNX id (nd_OP_is_dot_uscore_hash_lambda6 x2)) s0
  cd cs

d_OP_is_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry t0) => (t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_is_dot_uscore_hash_lambda6 x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> d_C__case_0 x3 x1 x4 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_is_dot_uscore_hash_lambda6 x1 l cd cs)
    (d_OP_is_dot_uscore_hash_lambda6 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_is_dot_uscore_hash_lambda6 x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (d_OP_is_dot_uscore_hash_lambda6 x1 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Test.Prop.is._#lambda6" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Prop.is._#lambda6" (showCons x2))

nd_OP_is_dot_uscore_hash_lambda6 :: forall t0 . (Curry_Prelude.Curry t0) => Func
  t0 Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_is_dot_uscore_hash_lambda6 x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Cons x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_0 x3 x1 x4 s0 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (nd_OP_is_dot_uscore_hash_lambda6 x1 l s cd cs)
    (nd_OP_is_dot_uscore_hash_lambda6 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    nd_OP_is_dot_uscore_hash_lambda6 x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c
    (nd_OP_is_dot_uscore_hash_lambda6 x1 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Test.Prop.is._#lambda6" [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Prop.is._#lambda6" (showCons x2))

d_C_isAlways :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover
  -> ConstStore -> C_Prop
d_C_isAlways x1 cd cs = Curry_Prelude.d_OP_dot (d_C_test x1)
  Curry_Prelude.d_C_all cd cs

nd_C_isAlways :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Func t0 Curry_Prelude.C_Bool) C_Prop
nd_C_isAlways x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (nd_C_test x1)) (wrapNX id
  Curry_Prelude.nd_C_all) s0 cd cs

d_C_isEventually :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> (t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> Cover
  -> ConstStore -> C_Prop
d_C_isEventually x1 cd cs = Curry_Prelude.d_OP_dot (d_C_test x1)
  Curry_Prelude.d_C_any cd cs

nd_C_isEventually :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> IDSupply
  -> Cover -> ConstStore -> Func (Func t0 Curry_Prelude.C_Bool) C_Prop
nd_C_isEventually x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id (nd_C_test x1)) (wrapNX id
  Curry_Prelude.nd_C_any) s0 cd cs

d_C_uniquely :: Cover -> ConstStore -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Prop
d_C_uniquely cd cs = Curry_Prelude.d_C_flip (acceptCs id d_C_is)
  Curry_Prelude.d_C_id

d_C_always :: Cover -> ConstStore -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Prop
d_C_always cd cs = Curry_Prelude.d_C_flip d_C_isAlways Curry_Prelude.d_C_id

d_C_eventually :: Cover -> ConstStore -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Prop
d_C_eventually cd cs = Curry_Prelude.d_C_flip d_C_isEventually
  Curry_Prelude.d_C_id

d_C_failing :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> C_Prop
d_C_failing x1 cd cs = d_C_test x1 Curry_Prelude.d_C_null cd cs

d_C_successful :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_Prop
d_C_successful x1 cd cs = d_C_test x1 (Curry_Prelude.d_OP_dot
  Curry_Prelude.d_C_not Curry_Prelude.d_C_null cd cs) cd cs

d_C_deterministic :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover
  -> ConstStore -> C_Prop
d_C_deterministic x1 cd cs = d_C_is x1 (Curry_Prelude.d_C_const
  Curry_Prelude.C_True) cd cs

d_OP_hash :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Curry_Prelude.C_Int
  -> Cover -> ConstStore -> C_Prop
d_OP_hash x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString "#")
  cd cs

d_OP_hash_lt :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Prop
d_OP_hash_lt x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "#<") cd cs

d_OP_hash_gt :: forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> C_Prop
d_OP_hash_gt x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "#>") cd cs

d_C_for :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> C_Prop) -> Cover -> ConstStore -> C_Prop
d_C_for x1 x2 cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString "for")
  cd cs

nd_C_for :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0 C_Prop
  -> IDSupply -> Cover -> ConstStore -> C_Prop
nd_C_for x1 x2 s cd cs = d_C_propUndefinedError (Curry_Prelude.toCurryString
  "for") cd cs

d_C_label :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> C_Prop -> Cover
  -> ConstStore -> C_Prop
d_C_label x1 x2 cd cs = case x2 of
  C_Prop x3 -> C_Prop (Curry_Prelude.d_C_map (d_C_updStamp (acceptCs id
    (Curry_Prelude.OP_Cons x1))) x3 cd cs)
  Choice_C_Prop d i l r -> narrow d i (d_C_label x1 l cd cs) (d_C_label x1 r cd
    cs)
  Choices_C_Prop d i xs -> narrows cs d i (\z -> d_C_label x1 z cd cs) xs
  Guard_C_Prop d c e -> guardCons d c (d_C_label x1 e cd $! addCs c cs)
  Fail_C_Prop d info -> failCons d (traceFail "Test.Prop.label" [show x1, show
    x2] info)
  _ -> failCons cd (consFail "Test.Prop.label" (showCons x2))

d_C_classify :: Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> C_Prop -> Cover -> ConstStore
  -> C_Prop
d_C_classify x1 x2 cd cs = case x1 of
  Curry_Prelude.C_True -> d_C_label x2
  Curry_Prelude.C_False -> Curry_Prelude.d_C_id
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C_classify l x2 cd cs)
    (d_C_classify r x2 cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C_classify z x2
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C_classify e x2 cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Test.Prop.classify"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Test.Prop.classify" (showCons x1))

d_C_trivial :: Cover -> ConstStore -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Prop -> Cover -> ConstStore -> C_Prop
d_C_trivial cd cs = Curry_Prelude.d_C_flip (acceptCs id d_C_classify)
  (Curry_Prelude.toCurryString "trivial")

d_C_collect :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore -> t0
  -> Cover -> ConstStore -> C_Prop -> Cover -> ConstStore -> C_Prop
d_C_collect cd cs = Curry_Prelude.d_OP_dot (acceptCs id d_C_label)
  Curry_Prelude.d_C_show cd cs

d_C_collectAs :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> C_Prop -> Cover -> ConstStore -> C_Prop
d_C_collectAs x1 cd cs = Curry_Prelude.d_OP_dot (acceptCs id d_C_label)
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_OP_plus_plus x1 (Curry_Prelude.toCurryString ": ") cd cs))
  Curry_Prelude.d_C_show cd cs) cd cs

d_C_valuesOf :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_valuesOf cd cs = Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
  "Test.Prop.valuesOf undefined. Use Test.EasyCheck to actually run it!") cd cs

d_C_propUndefinedError :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore -> t0
d_C_propUndefinedError x1 cd cs = Curry_Prelude.d_OP_dollar
  Curry_Prelude.d_C_error (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.toCurryString "Test.Prop.") (Curry_Prelude.d_OP_plus_plus x1
  (Curry_Prelude.toCurryString
  " undefined. Use Test.EasyCheck to actually run it!") cd cs) cd cs) cd cs

d_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> (t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool) -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_0 x3 x1 x4 cd cs = case x4 of
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply x1 x3 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_0 x3 x1 l cd cs)
    (d_C__case_0 x3 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_0 x3
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_0 x3 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Test.Prop._case_0"
    [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Test.Prop._case_0" (showCons x4))

nd_C__case_0 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Func t0
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_0 x3 x1 x4 s cd cs = case x4 of
  Curry_Prelude.OP_List -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_C_apply x1 x3 s0 cd cs
  Curry_Prelude.OP_Cons x5 x6 -> Curry_Prelude.C_False
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_0 x3 x1 l s cd
    cs) (nd_C__case_0 x3 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_0 x3
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_0 x3 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Test.Prop._case_0"
    [show x3, show x1, show x4] info)
  _ -> failCons cd (consFail "Test.Prop._case_0" (showCons x4))

d_C__case_1 :: Curry_Prelude.C_Bool -> C_Prop -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Prop
d_C__case_1 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> C_Prop (Curry_Prelude.OP_Cons (d_C_notest cd cs)
    Curry_Prelude.OP_List)
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x1 x2 l cd cs)
    (d_C__case_1 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x1 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x1 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Test.Prop._case_1"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Test.Prop._case_1" (showCons x3))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Result
d_C__case_5 x3 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_4 x7 x3 x5 x6 cd cs
  Curry_Prelude.OP_List -> C_Ambigious x5 (Curry_Prelude.d_C_map
    Curry_Prelude.d_C_show x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x3 l cd cs)
    (d_C__case_5 x3 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x3 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_5 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Test.Prop._case_5"
    [show x3, show x5] info)
  _ -> failCons cd (consFail "Test.Prop._case_5" (showCons x5))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Bool -> Curry_Prelude.OP_List t0 -> Curry_Prelude.OP_List
  Curry_Prelude.C_Bool -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Result
d_C__case_4 x7 x3 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_3 x3 x5 x7 cd cs
  Curry_Prelude.C_False -> d_C__case_2 x3 x5 x7 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x7 x3 x5 l cd
    cs) (d_C__case_4 x7 x3 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x7 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_4 x7 x3 x5 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Test.Prop._case_4"
    [show x7, show x3, show x5, show x6] info)
  _ -> failCons cd (consFail "Test.Prop._case_4" (showCons x6))

d_C__case_2 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Result
d_C__case_2 x3 x5 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> C_Falsified (Curry_Prelude.d_C_map
    Curry_Prelude.d_C_show x3 cd cs)
  Curry_Prelude.OP_Cons x10 x11 -> C_Ambigious x5 (Curry_Prelude.d_C_map
    Curry_Prelude.d_C_show x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_2 x3 x5 l cd cs)
    (d_C__case_2 x3 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_2 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_2 x3 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Test.Prop._case_2"
    [show x3, show x5, show x7] info)
  _ -> failCons cd (consFail "Test.Prop._case_2" (showCons x7))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Bool -> Curry_Prelude.OP_List
  Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Result
d_C__case_3 x3 x5 x7 cd cs = case x7 of
  Curry_Prelude.OP_List -> C_Ok
  Curry_Prelude.OP_Cons x8 x9 -> C_Ambigious x5 (Curry_Prelude.d_C_map
    Curry_Prelude.d_C_show x3 cd cs)
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x3 x5 l cd cs)
    (d_C__case_3 x3 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x3
    x5 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_3 x3 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail "Test.Prop._case_3"
    [show x3, show x5, show x7] info)
  _ -> failCons cd (consFail "Test.Prop._case_3" (showCons x7))

d_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> t0
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_6 x4 x3 x1 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_C_unless x2
    (Curry_Prelude.d_C_putStr (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.toCurryString ": OK\n") cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_return Curry_Prelude.C_Nothing cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_gt_gt (Curry_Prelude.d_OP_dollar
    Curry_Prelude.d_C_putStrLn (Curry_Prelude.d_OP_plus_plus x1
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString
    ": FAILED!\nResults: ") (Curry_Prelude.d_C_show (Curry_Prelude.OP_Tuple2 x3
    x4) cd cs) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_return
    (Curry_Prelude.C_Just x1) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x4 x3 x1 x2 l
    cd cs) (d_C__case_6 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x4 x3
    x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_6 x4 x3 x1 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Test.Prop._case_6"
    [show x4, show x3, show x1, show x2, show x5] info)
  _ -> failCons cd (consFail "Test.Prop._case_6" (showCons x5))

