{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module FlatCurry.Annotated.Curry_Pretty
  ( d_C_ppProg
  , nd_C_ppProg
  , d_C_ppHeader
  , nd_C_ppHeader
  , d_C_ppExports
  , nd_C_ppExports
  , d_C_ppTypeExport
  , nd_C_ppTypeExport
  , d_C_ppConsExports
  , nd_C_ppConsExports
  , d_C_ppFuncExports
  , nd_C_ppFuncExports
  , d_C_ppImports
  , nd_C_ppImports
  , d_C_ppImport
  , nd_C_ppImport
  , d_C_ppOpDecls
  , nd_C_ppOpDecls
  , d_C_ppOpDecl
  , nd_C_ppOpDecl
  , d_C_ppFixity
  , nd_C_ppFixity
  , d_C_ppTypeDecls
  , nd_C_ppTypeDecls
  , d_C_ppTypeDecl
  , nd_C_ppTypeDecl
  , d_C_ppConsDecls
  , nd_C_ppConsDecls
  , d_C_ppConsDecl
  , nd_C_ppConsDecl
  , d_C_ppTypeExp
  , nd_C_ppTypeExp
  , d_C_ppTypeExpr
  , nd_C_ppTypeExpr
  , d_C_ppTVarIndex
  , nd_C_ppTVarIndex
  , d_C_ppFuncDecls
  , nd_C_ppFuncDecls
  , d_C_ppFuncDecl
  , nd_C_ppFuncDecl
  , d_C_ppRule
  , nd_C_ppRule
  , d_C_ppExp
  , nd_C_ppExp
  , d_C_ppExpr
  , nd_C_ppExpr
  , d_C_ppAVarIndex
  , nd_C_ppAVarIndex
  , d_C_ppVarIndex
  , nd_C_ppVarIndex
  , d_C_ppLiteral
  , nd_C_ppLiteral
  , d_C_showEscape
  , d_C_ppComb
  , nd_C_ppComb
  , d_C_ppDecls
  , nd_C_ppDecls
  , d_C_ppDecl
  , nd_C_ppDecl
  , d_C_ppCaseType
  , nd_C_ppCaseType
  , d_C_ppBranch
  , nd_C_ppBranch
  , d_C_ppPattern
  , nd_C_ppPattern
  , d_C_ppPrefixOp
  , nd_C_ppPrefixOp
  , d_C_ppInfixOp
  , nd_C_ppInfixOp
  , d_C_ppQName
  , nd_C_ppQName
  , d_C_isInfixOp
  , d_C_isListId
  , d_C_isTupleId
  , d_C_indent
  , nd_C_indent )
  where

import Basics
import qualified FlatCurry.Annotated.Curry_Types
import qualified FlatCurry.Curry_Types
import qualified Curry_Prelude
import qualified Curry_Pretty


d_C_ppProg :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AProg t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppProg x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x3 x4 x5 x6 -> Curry_Pretty.d_C_compose
    (Curry_Pretty.d_OP_lt_dollar_plus_dollar_gt cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppHeader x2 x4 x5 cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (d_C_ppImports cd cs) x3 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppOpDecls cd cs) x6 cd
    cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppTypeDecls cd cs)
    x4 cd cs) (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (d_C_ppFuncDecls
    cd cs) x5 cd cs) Curry_Prelude.OP_List))))) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AProg d i l r -> narrow d i
    (d_C_ppProg l cd cs) (d_C_ppProg r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AProg d i xs -> narrows cs d i
    (\z -> d_C_ppProg z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AProg d c e -> guardCons d c
    (d_C_ppProg e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AProg d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppProg" (showCons x1))

nd_C_ppProg :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AProg t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppProg x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AProg x2 x3 x4 x5 x6 -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s0 = leftSupply s20
                      s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s0 `seq` (s17 `seq` Curry_Pretty.nd_C_compose
    (Curry_Pretty.nd_OP_lt_dollar_plus_dollar_gt s0 cd cs) (let s1 = leftSupply
                                                                  s17
                                                                s16 = rightSupply
                                                                  s17
    in s1 `seq` (s16 `seq` Curry_Prelude.OP_Cons (nd_C_ppHeader x2 x4 x5 s1 cd
    cs) (let s4 = leftSupply s16
             s15 = rightSupply s16
    in s4 `seq` (s15 `seq` Curry_Prelude.OP_Cons (let s3 = leftSupply s4
                                                      s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_ppImports s2 cd cs) x3
    s3 cd cs)) (let s7 = leftSupply s15
                    s14 = rightSupply s15
    in s7 `seq` (s14 `seq` Curry_Prelude.OP_Cons (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppOpDecls s5 cd cs) x6
    s6 cd cs)) (let s10 = leftSupply s14
                    s13 = rightSupply s14
    in s10 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s9 = leftSupply s10
                                                       s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeDecls s8 cd cs)
    x4 s9 cd cs)) (Curry_Prelude.OP_Cons (let s12 = leftSupply s13
                                              s11 = rightSupply s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (nd_C_ppFuncDecls s11 cd
    cs) x5 s12 cd cs)) Curry_Prelude.OP_List))))))))) s18 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_AProg d i l r -> narrow d i
    (nd_C_ppProg l s cd cs) (nd_C_ppProg r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AProg d i xs -> narrows cs d i
    (\z -> nd_C_ppProg z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AProg d c e -> guardCons d c
    (nd_C_ppProg e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AProg d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppProg" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppProg" (showCons x1))

d_C_ppHeader :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppHeader x1 x2 x3 cd cs = Curry_Prelude.d_OP_dollar (d_C_indent cd cs)
  (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
  (Curry_Prelude.toCurryString "module") cd cs) cd cs) (Curry_Pretty.d_C_text x1
  cd cs) cd cs) (Curry_Prelude.OP_Cons (d_C_ppExports x2 x3 cd cs)
  (Curry_Prelude.OP_Cons (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString
  "where") cd cs) Curry_Prelude.OP_List))) cd cs) cd cs

nd_C_ppHeader :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppHeader x1 x2 x3 s cd cs = let s19 = s
  in s19 `seq` (let s18 = leftSupply s19
                    s20 = rightSupply s19
                    s0 = leftSupply s20
                    s16 = rightSupply s20
  in s18 `seq` (s20 `seq` (s0 `seq` (s16 `seq` Curry_Prelude.nd_OP_dollar
  (nd_C_indent s0 cd cs) (let s15 = leftSupply s16
                              s17 = rightSupply s16
                              s1 = leftSupply s17
                              s14 = rightSupply s17
  in s15 `seq` (s17 `seq` (s1 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
  (Curry_Pretty.nd_C_sep s1 cd cs) (let s9 = leftSupply s14
                                        s13 = rightSupply s14
  in s9 `seq` (s13 `seq` Curry_Prelude.OP_Cons (let s8 = leftSupply s9
                                                    s10 = rightSupply s9
                                                    s5 = leftSupply s10
                                                    s7 = rightSupply s10
  in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
  (let s4 = leftSupply s5
       s6 = rightSupply s5
       s2 = leftSupply s6
       s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "module") s3 cd cs) s4 cd cs))))
  (Curry_Pretty.nd_C_text x1 s7 cd cs) s8 cd cs)))) (let s11 = leftSupply s13
                                                         s12 = rightSupply s13
  in s11 `seq` (s12 `seq` Curry_Prelude.OP_Cons (nd_C_ppExports x2 x3 s11 cd cs)
  (Curry_Prelude.OP_Cons (Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
  "where") s12 cd cs) Curry_Prelude.OP_List))))) s15 cd cs)))) s18 cd cs))))

d_C_ppExports :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppExports x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Pretty.d_C_tupledSpaced cd cs) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_map d_C_ppTypeExport x1 cd cs) (d_C_ppFuncExports x2 cd cs)
  cd cs) cd cs

nd_C_ppExports :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppExports x1 x2 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (Curry_Pretty.nd_C_tupledSpaced s0 cd cs) (let s1 = leftSupply s3
                                                 s2 = rightSupply s3
  in s1 `seq` (s2 `seq` Curry_Prelude.d_OP_plus_plus (Curry_Prelude.nd_C_map
  (wrapNX id nd_C_ppTypeExport) x1 s1 cd cs) (nd_C_ppFuncExports x2 s2 cd cs) cd
  cs)) s4 cd cs))))

d_C_ppTypeExport :: FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppTypeExport x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Type x2 x3 x4 x5 -> d_C__case_40 x3 x5 x2
    (Curry_Prelude.d_OP_eq_eq x3 FlatCurry.Curry_Types.C_Private cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x6 x7 x8 x9 -> d_C__case_37 x7 x6
    (Curry_Prelude.d_OP_eq_eq x7 FlatCurry.Curry_Types.C_Private cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (d_C_ppTypeExport l cd cs) (d_C_ppTypeExport r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C_ppTypeExport z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c
    (d_C_ppTypeExport e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeExport" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeExport" (showCons
    x1))

nd_C_ppTypeExport :: FlatCurry.Curry_Types.C_TypeDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppTypeExport x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Type x2 x3 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_40 x3 x5 x2 (Curry_Prelude.d_OP_eq_eq x3
    FlatCurry.Curry_Types.C_Private cd cs) s0 cd cs
  FlatCurry.Curry_Types.C_TypeSyn x6 x7 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_37 x7 x6 (Curry_Prelude.d_OP_eq_eq x7
    FlatCurry.Curry_Types.C_Private cd cs) s0 cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i
    (nd_C_ppTypeExport l s cd cs) (nd_C_ppTypeExport r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeExport z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c
    (nd_C_ppTypeExport e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeExport" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeExport" (showCons
    x1))

d_OP_ppTypeExport_dot_isPublicCons_dot_9 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_ppTypeExport_dot_isPublicCons_dot_9 x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x2 x3 x4 x5 -> Curry_Prelude.d_OP_eq_eq x4
    FlatCurry.Curry_Types.C_Public cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_OP_ppTypeExport_dot_isPublicCons_dot_9 l cd cs)
    (d_OP_ppTypeExport_dot_isPublicCons_dot_9 r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_OP_ppTypeExport_dot_isPublicCons_dot_9 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c
    (d_OP_ppTypeExport_dot_isPublicCons_dot_9 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeExport.isPublicCons.9" [show x1] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.Pretty.ppTypeExport.isPublicCons.9" (showCons x1))

d_C_ppConsExports :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
d_C_ppConsExports x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_ppConsExports_dot_uscore_hash_lambda3) Curry_Prelude.OP_List x1 cd cs

nd_C_ppConsExports :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
nd_C_ppConsExports x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  nd_OP_ppConsExports_dot_uscore_hash_lambda3)) Curry_Prelude.OP_List x1 s0 cd
  cs

d_OP_ppConsExports_dot_uscore_hash_lambda3 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
d_OP_ppConsExports_dot_uscore_hash_lambda3 x1 x2 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x3 x4 x5 x6 -> d_C__case_35 x2 x3 x5 cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (d_OP_ppConsExports_dot_uscore_hash_lambda3 l x2 cd cs)
    (d_OP_ppConsExports_dot_uscore_hash_lambda3 r x2 cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_OP_ppConsExports_dot_uscore_hash_lambda3 z x2 cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c
    (d_OP_ppConsExports_dot_uscore_hash_lambda3 e x2 cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppConsExports._#lambda3" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.Pretty.ppConsExports._#lambda3" (showCons x1))

nd_OP_ppConsExports_dot_uscore_hash_lambda3 :: FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
nd_OP_ppConsExports_dot_uscore_hash_lambda3 x1 x2 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x3 x4 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_35 x2 x3 x5 s0 cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i
    (nd_OP_ppConsExports_dot_uscore_hash_lambda3 l x2 s cd cs)
    (nd_OP_ppConsExports_dot_uscore_hash_lambda3 r x2 s cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    nd_OP_ppConsExports_dot_uscore_hash_lambda3 z x2 s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c
    (nd_OP_ppConsExports_dot_uscore_hash_lambda3 e x2 s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppConsExports._#lambda3" [show x1, show x2]
    info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.Pretty.ppConsExports._#lambda3" (showCons x1))

d_C_ppFuncExports :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
d_C_ppFuncExports x1 cd cs = Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_ppFuncExports_dot_uscore_hash_lambda7) Curry_Prelude.OP_List x1 cd cs

nd_C_ppFuncExports :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
nd_C_ppFuncExports x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  nd_OP_ppFuncExports_dot_uscore_hash_lambda7)) Curry_Prelude.OP_List x1 s0 cd
  cs

d_OP_ppFuncExports_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0 -> Curry_Prelude.OP_List
  Curry_Pretty.C_Doc -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Pretty.C_Doc
d_OP_ppFuncExports_dot_uscore_hash_lambda7 x1 x2 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x3 x4 x5 x6 x7 -> d_C__case_34 x2 x3
    x5 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_OP_ppFuncExports_dot_uscore_hash_lambda7 l x2 cd cs)
    (d_OP_ppFuncExports_dot_uscore_hash_lambda7 r x2 cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_OP_ppFuncExports_dot_uscore_hash_lambda7 z x2 cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_OP_ppFuncExports_dot_uscore_hash_lambda7 e x2 cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppFuncExports._#lambda7" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.Pretty.ppFuncExports._#lambda7" (showCons x1))

nd_OP_ppFuncExports_dot_uscore_hash_lambda7 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0 -> Curry_Prelude.OP_List
  Curry_Pretty.C_Doc -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Pretty.C_Doc
nd_OP_ppFuncExports_dot_uscore_hash_lambda7 x1 x2 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x3 x4 x5 x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_34 x2 x3 x5 s0 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (nd_OP_ppFuncExports_dot_uscore_hash_lambda7 l x2 s cd cs)
    (nd_OP_ppFuncExports_dot_uscore_hash_lambda7 r x2 s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> nd_OP_ppFuncExports_dot_uscore_hash_lambda7 z x2 s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (nd_OP_ppFuncExports_dot_uscore_hash_lambda7 e x2 s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppFuncExports._#lambda7" [show x1
    , show x2] info)
  _ -> failCons cd (consFail
    "FlatCurry.Annotated.Pretty.ppFuncExports._#lambda7" (showCons x1))

d_C_ppImports :: Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppImports cd cs = Curry_Prelude.d_OP_dot (Curry_Pretty.d_C_vsep cd cs)
  (Curry_Prelude.d_C_map d_C_ppImport) cd cs

nd_C_ppImports :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_Pretty.C_Doc
nd_C_ppImports s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Curry_Pretty.nd_C_vsep s0 cd
  cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppImport))) s1 cd cs))

d_C_ppImport :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppImport x1 cd cs = Curry_Prelude.d_OP_dollar (d_C_indent cd cs)
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
  (Curry_Prelude.toCurryString "import") cd cs) cd cs) (Curry_Pretty.d_C_text x1
  cd cs) cd cs) cd cs

nd_C_ppImport :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppImport x1 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s0 = leftSupply s12
                    s8 = rightSupply s12
  in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_OP_dollar
  (nd_C_indent s0 cd cs) (let s7 = leftSupply s8
                              s9 = rightSupply s8
                              s4 = leftSupply s9
                              s6 = rightSupply s9
  in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
  (let s3 = leftSupply s4
       s5 = rightSupply s4
       s1 = leftSupply s5
       s2 = rightSupply s5
  in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
  (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Curry_Pretty.nd_C_text
  (Curry_Prelude.toCurryString "import") s2 cd cs) s3 cd cs))))
  (Curry_Pretty.nd_C_text x1 s6 cd cs) s7 cd cs)))) s10 cd cs))))

d_C_ppOpDecls :: Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppOpDecls cd cs = Curry_Prelude.d_OP_dot (Curry_Pretty.d_C_vsep cd cs)
  (Curry_Prelude.d_C_map d_C_ppOpDecl) cd cs

nd_C_ppOpDecls :: IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_OpDecl) Curry_Pretty.C_Doc
nd_C_ppOpDecls s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (Curry_Pretty.nd_C_vsep s0 cd
  cs) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppOpDecl))) s1 cd cs))

d_C_ppOpDecl :: FlatCurry.Curry_Types.C_OpDecl -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppOpDecl x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Op x2 x3 x4 -> Curry_Prelude.d_OP_dollar (d_C_indent
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppFixity
    x3 cd cs) cd cs) (Curry_Pretty.d_C_int x4 cd cs) cd cs) cd cs)
    (d_C_ppInfixOp x2 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_OpDecl d i l r -> narrow d i (d_C_ppOpDecl l cd
    cs) (d_C_ppOpDecl r cd cs)
  FlatCurry.Curry_Types.Choices_C_OpDecl d i xs -> narrows cs d i (\z ->
    d_C_ppOpDecl z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_OpDecl d c e -> guardCons d c (d_C_ppOpDecl e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_OpDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppOpDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppOpDecl" (showCons
    x1))

nd_C_ppOpDecl :: FlatCurry.Curry_Types.C_OpDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppOpDecl x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Op x2 x3 x4 -> let s19 = s
    in s19 `seq` (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s0 = leftSupply s20
                      s16 = rightSupply s20
    in s18 `seq` (s20 `seq` (s0 `seq` (s16 `seq` Curry_Prelude.nd_OP_dollar
    (nd_C_indent s0 cd cs) (let s15 = leftSupply s16
                                s17 = rightSupply s16
                                s12 = leftSupply s17
                                s14 = rightSupply s17
    in s15 `seq` (s17 `seq` (s12 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s1 = leftSupply s13
         s9 = rightSupply s13
    in s11 `seq` (s13 `seq` (s1 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s8 = leftSupply s9
                                                  s10 = rightSupply s9
                                                  s5 = leftSupply s10
                                                  s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s5 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (nd_C_ppFixity x3 s3 cd cs) s4 cd
    cs)))) (Curry_Pretty.nd_C_int x4 s7 cd cs) s8 cd cs)))) s11 cd cs))))
    (nd_C_ppInfixOp x2 s14 cd cs) s15 cd cs)))) s18 cd cs))))
  FlatCurry.Curry_Types.Choice_C_OpDecl d i l r -> narrow d i (nd_C_ppOpDecl l s
    cd cs) (nd_C_ppOpDecl r s cd cs)
  FlatCurry.Curry_Types.Choices_C_OpDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppOpDecl z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_OpDecl d c e -> guardCons d c (nd_C_ppOpDecl e s
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_OpDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppOpDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppOpDecl" (showCons
    x1))

d_C_ppFixity :: FlatCurry.Curry_Types.C_Fixity -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppFixity x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_InfixOp -> Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infix") cd cs
  FlatCurry.Curry_Types.C_InfixlOp -> Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infixl") cd cs
  FlatCurry.Curry_Types.C_InfixrOp -> Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "infixr") cd cs
  FlatCurry.Curry_Types.Choice_C_Fixity d i l r -> narrow d i (d_C_ppFixity l cd
    cs) (d_C_ppFixity r cd cs)
  FlatCurry.Curry_Types.Choices_C_Fixity d i xs -> narrows cs d i (\z ->
    d_C_ppFixity z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Fixity d c e -> guardCons d c (d_C_ppFixity e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Fixity d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppFixity" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppFixity" (showCons
    x1))

nd_C_ppFixity :: FlatCurry.Curry_Types.C_Fixity -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppFixity x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_InfixOp -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "infix") s0
    cd cs
  FlatCurry.Curry_Types.C_InfixlOp -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "infixl") s0
    cd cs
  FlatCurry.Curry_Types.C_InfixrOp -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "infixr") s0
    cd cs
  FlatCurry.Curry_Types.Choice_C_Fixity d i l r -> narrow d i (nd_C_ppFixity l s
    cd cs) (nd_C_ppFixity r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Fixity d i xs -> narrows cs d i (\z ->
    nd_C_ppFixity z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Fixity d c e -> guardCons d c (nd_C_ppFixity e s
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Fixity d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppFixity" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppFixity" (showCons
    x1))

d_C_ppTypeDecls :: Cover -> ConstStore -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppTypeDecls cd cs = Curry_Prelude.d_OP_dot (Curry_Pretty.d_C_compose
  (Curry_Pretty.d_OP_lt_dollar_plus_dollar_gt cd cs)) (Curry_Prelude.d_C_map
  d_C_ppTypeDecl) cd cs

nd_C_ppTypeDecls :: IDSupply -> Cover -> ConstStore -> Func
  (Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeDecl) Curry_Pretty.C_Doc
nd_C_ppTypeDecls s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Pretty.nd_C_compose (Curry_Pretty.nd_OP_lt_dollar_plus_dollar_gt s0 cd
  cs))) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppTypeDecl))) s1 cd
  cs))

d_C_ppTypeDecl :: FlatCurry.Curry_Types.C_TypeDecl -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppTypeDecl x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Type x2 x3 x4 x5 -> Curry_Prelude.d_OP_dollar
    (d_C_indent cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_dollar_dollar_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "data") cd cs) cd cs) (d_C_ppQName x2 cd cs) cd
    cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.d_C_map d_C_ppTVarIndex x4 cd cs) cd cs) cd cs) cd cs)
    (d_C_ppConsDecls x5 cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TypeSyn x6 x7 x8 x9 -> Curry_Prelude.d_OP_dollar
    (d_C_indent cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_slash_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "type") cd cs) cd cs) (d_C_ppQName x6 cd cs) cd
    cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.d_C_map d_C_ppTVarIndex x8 cd cs) cd cs) cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_equals cd cs) cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppTypeExp cd cs) x9 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i (d_C_ppTypeDecl
    l cd cs) (d_C_ppTypeDecl r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    d_C_ppTypeDecl z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c (d_C_ppTypeDecl
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeDecl" (showCons
    x1))

nd_C_ppTypeDecl :: FlatCurry.Curry_Types.C_TypeDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppTypeDecl x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Type x2 x3 x4 x5 -> let s31 = s
    in s31 `seq` (let s30 = leftSupply s31
                      s32 = rightSupply s31
                      s0 = leftSupply s32
                      s28 = rightSupply s32
    in s30 `seq` (s32 `seq` (s0 `seq` (s28 `seq` Curry_Prelude.nd_OP_dollar
    (nd_C_indent s0 cd cs) (let s27 = leftSupply s28
                                s29 = rightSupply s28
                                s24 = leftSupply s29
                                s26 = rightSupply s29
    in s27 `seq` (s29 `seq` (s24 `seq` (s26 `seq` Curry_Prelude.nd_C_apply
    (let s23 = leftSupply s24
         s25 = rightSupply s24
         s1 = leftSupply s25
         s21 = rightSupply s25
    in s23 `seq` (s25 `seq` (s1 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_dollar_dollar_gt s1 cd cs) (let s20 = leftSupply s21
                                                           s22 = rightSupply s21
                                                           s13 = leftSupply s22
                                                           s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s13 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s12 = leftSupply s13
         s14 = rightSupply s13
         s2 = leftSupply s14
         s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (let s9 = leftSupply s10
                                                  s11 = rightSupply s10
                                                  s6 = leftSupply s11
                                                  s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s3 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "data") s4 cd cs) s5 cd cs)))) (nd_C_ppQName x2
    s8 cd cs) s9 cd cs)))) s12 cd cs)))) (let s17 = leftSupply s18
                                              s19 = rightSupply s18
                                              s15 = leftSupply s19
                                              s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s15 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s15 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppTVarIndex) x4 s16 cd cs) s17 cd cs)))) s20 cd cs)))) s23 cd cs))))
    (nd_C_ppConsDecls x5 s26 cd cs) s27 cd cs)))) s30 cd cs))))
  FlatCurry.Curry_Types.C_TypeSyn x6 x7 x8 x9 -> let s41 = s
    in s41 `seq` (let s40 = leftSupply s41
                      s42 = rightSupply s41
                      s0 = leftSupply s42
                      s38 = rightSupply s42
    in s40 `seq` (s42 `seq` (s0 `seq` (s38 `seq` Curry_Prelude.nd_OP_dollar
    (nd_C_indent s0 cd cs) (let s37 = leftSupply s38
                                s39 = rightSupply s38
                                s24 = leftSupply s39
                                s35 = rightSupply s39
    in s37 `seq` (s39 `seq` (s24 `seq` (s35 `seq` Curry_Prelude.nd_C_apply
    (let s23 = leftSupply s24
         s25 = rightSupply s24
         s1 = leftSupply s25
         s21 = rightSupply s25
    in s23 `seq` (s25 `seq` (s1 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_slash_gt s1 cd cs) (let s20 = leftSupply s21
                                                   s22 = rightSupply s21
                                                   s13 = leftSupply s22
                                                   s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s13 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s12 = leftSupply s13
         s14 = rightSupply s13
         s2 = leftSupply s14
         s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (let s9 = leftSupply s10
                                                  s11 = rightSupply s10
                                                  s6 = leftSupply s11
                                                  s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s3 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "type") s4 cd cs) s5 cd cs)))) (nd_C_ppQName x6
    s8 cd cs) s9 cd cs)))) s12 cd cs)))) (let s17 = leftSupply s18
                                              s19 = rightSupply s18
                                              s15 = leftSupply s19
                                              s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s15 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s15 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppTVarIndex) x8 s16 cd cs) s17 cd cs)))) s20 cd cs)))) s23 cd cs))))
    (let s34 = leftSupply s35
         s36 = rightSupply s35
         s29 = leftSupply s36
         s33 = rightSupply s36
    in s34 `seq` (s36 `seq` (s29 `seq` (s33 `seq` Curry_Prelude.nd_C_apply
    (let s28 = leftSupply s29
         s30 = rightSupply s29
         s26 = leftSupply s30
         s27 = rightSupply s30
    in s28 `seq` (s30 `seq` (s26 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s26 cd cs) (Curry_Pretty.nd_C_equals s27 cd
    cs) s28 cd cs)))) (let s32 = leftSupply s33
                           s31 = rightSupply s33
    in s32 `seq` (s31 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp s31 cd cs)
    x9 s32 cd cs)) s34 cd cs)))) s37 cd cs)))) s40 cd cs))))
  FlatCurry.Curry_Types.Choice_C_TypeDecl d i l r -> narrow d i (nd_C_ppTypeDecl
    l s cd cs) (nd_C_ppTypeDecl r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeDecl z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeDecl d c e -> guardCons d c (nd_C_ppTypeDecl
    e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeDecl" (showCons
    x1))

d_C_ppConsDecls :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppConsDecls x1 cd cs = Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_vsep cd
  cs) (Curry_Prelude.d_C_zipWith (Curry_Pretty.d_OP_lt_plus_gt cd cs)
  (Curry_Prelude.OP_Cons (Curry_Pretty.d_C_equals cd cs)
  (Curry_Prelude.d_C_repeat (Curry_Pretty.d_C_bar cd cs) cd cs))
  (Curry_Prelude.d_C_map d_C_ppConsDecl x1 cd cs) cd cs) cd cs

nd_C_ppConsDecls :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppConsDecls x1 s cd cs = let s11 = s
  in s11 `seq` (let s10 = leftSupply s11
                    s12 = rightSupply s11
                    s0 = leftSupply s12
                    s7 = rightSupply s12
  in s10 `seq` (s12 `seq` (s0 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar
  (Curry_Pretty.nd_C_vsep s0 cd cs) (let s8 = leftSupply s7
                                         s9 = rightSupply s7
                                         s6 = leftSupply s8
                                         s1 = rightSupply s8
                                         s4 = leftSupply s9
                                         s5 = rightSupply s9
  in s8 `seq` (s9 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (s5 `seq`
  Curry_Prelude.nd_C_zipWith (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs)
  (let s2 = leftSupply s4
       s3 = rightSupply s4
  in s2 `seq` (s3 `seq` Curry_Prelude.OP_Cons (Curry_Pretty.nd_C_equals s2 cd
  cs) (Curry_Prelude.d_C_repeat (Curry_Pretty.nd_C_bar s3 cd cs) cd cs)))
  (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppConsDecl) x1 s5 cd cs) s6 cd
  cs)))))) s10 cd cs))))

d_C_ppConsDecl :: FlatCurry.Curry_Types.C_ConsDecl -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppConsDecl x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x2 x3 x4 x5 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x2 cd
    cs) (Curry_Prelude.d_C_map (d_C_ppTypeExpr (Curry_Prelude.C_Int 2#)) x5 cd
    cs)) cd cs
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i (d_C_ppConsDecl
    l cd cs) (d_C_ppConsDecl r cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    d_C_ppConsDecl z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c (d_C_ppConsDecl
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppConsDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppConsDecl" (showCons
    x1))

nd_C_ppConsDecl :: FlatCurry.Curry_Types.C_ConsDecl -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppConsDecl x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Cons x2 x3 x4 x5 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_OP_dollar
    (Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x2 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppTypeExpr (Curry_Prelude.C_Int
    2#))) x5 s2 cd cs))) s4 cd cs))))
  FlatCurry.Curry_Types.Choice_C_ConsDecl d i l r -> narrow d i (nd_C_ppConsDecl
    l s cd cs) (nd_C_ppConsDecl r s cd cs)
  FlatCurry.Curry_Types.Choices_C_ConsDecl d i xs -> narrows cs d i (\z ->
    nd_C_ppConsDecl z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_ConsDecl d c e -> guardCons d c (nd_C_ppConsDecl
    e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_ConsDecl d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppConsDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppConsDecl" (showCons
    x1))

d_C_ppTypeExp :: Cover -> ConstStore -> FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppTypeExp cd cs = d_C_ppTypeExpr (Curry_Prelude.C_Int 0#)

nd_C_ppTypeExp :: IDSupply -> Cover -> ConstStore -> Func
  FlatCurry.Curry_Types.C_TypeExpr Curry_Pretty.C_Doc
nd_C_ppTypeExp s cd cs = wrapNX id (nd_C_ppTypeExpr (Curry_Prelude.C_Int 0#))

d_C_ppTypeExpr :: Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_TypeExpr
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppTypeExpr x1 x2 cd cs = case x2 of
  FlatCurry.Curry_Types.C_TVar x3 -> d_C_ppTVarIndex x3 cd cs
  FlatCurry.Curry_Types.C_FuncType x4 x5 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_slash_gt cd cs) (d_C_ppTypeExpr (Curry_Prelude.C_Int
    1#) x4 cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_rarrow cd cs) cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppTypeExp cd cs) x5 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.C_TCons x6 x7 -> d_C__case_33 x7 x6 x1
    (Curry_Prelude.d_OP_amp_amp (d_C_isListId x6 cd cs)
    (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_length x7 cd cs)
    (Curry_Prelude.C_Int 1#) cd cs) cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (d_C_ppTypeExpr
    x1 l cd cs) (d_C_ppTypeExpr x1 r cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    d_C_ppTypeExpr x1 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c (d_C_ppTypeExpr
    x1 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeExpr" (showCons
    x2))

nd_C_ppTypeExpr :: Curry_Prelude.C_Int -> FlatCurry.Curry_Types.C_TypeExpr
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppTypeExpr x1 x2 s cd cs = case x2 of
  FlatCurry.Curry_Types.C_TVar x3 -> let s0 = s
    in s0 `seq` nd_C_ppTVarIndex x3 s0 cd cs
  FlatCurry.Curry_Types.C_FuncType x4 x5 -> let s20 = s
    in s20 `seq` (let s19 = leftSupply s20
                      s17 = rightSupply s20
    in s19 `seq` (s17 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s16 = leftSupply s17
                      s18 = rightSupply s17
                      s3 = leftSupply s18
                      s14 = rightSupply s18
    in s16 `seq` (s18 `seq` (s3 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_slash_gt s0 cd cs) (nd_C_ppTypeExpr
    (Curry_Prelude.C_Int 1#) x4 s1 cd cs) s2 cd cs)))) (let s13 = leftSupply s14
                                                            s15 = rightSupply
                                                              s14
                                                            s8 = leftSupply s15
                                                            s12 = rightSupply
                                                              s15
    in s13 `seq` (s15 `seq` (s8 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s5 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s5 cd cs) (Curry_Pretty.nd_C_rarrow s6 cd cs)
    s7 cd cs)))) (let s11 = leftSupply s12
                      s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp s10 cd cs)
    x5 s11 cd cs)) s13 cd cs)))) s16 cd cs)))) s19 cd cs))
  FlatCurry.Curry_Types.C_TCons x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_33 x7 x6 x1 (Curry_Prelude.d_OP_amp_amp (d_C_isListId
    x6 cd cs) (Curry_Prelude.d_OP_eq_eq (Curry_Prelude.d_C_length x7 cd cs)
    (Curry_Prelude.C_Int 1#) cd cs) cd cs) s0 cd cs
  FlatCurry.Curry_Types.Choice_C_TypeExpr d i l r -> narrow d i (nd_C_ppTypeExpr
    x1 l s cd cs) (nd_C_ppTypeExpr x1 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_TypeExpr d i xs -> narrows cs d i (\z ->
    nd_C_ppTypeExpr x1 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_TypeExpr d c e -> guardCons d c (nd_C_ppTypeExpr
    x1 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_TypeExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppTypeExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppTypeExpr" (showCons
    x2))

d_C_ppTVarIndex :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppTVarIndex x1 cd cs = let x2 = Curry_Prelude.d_C_apply
                                 (Curry_Prelude.d_C_concatMap
                                 d_OP_ppTVarIndex_dot_uscore_hash_lambda9 cd cs)
                                 (Curry_Prelude.d_C_enumFrom
                                 (Curry_Prelude.C_Int 0#) cd cs) cd cs
  in Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
  (Curry_Prelude.d_OP_bang_bang x2 x1 cd cs) cd cs

nd_C_ppTVarIndex :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C_ppTVarIndex x1 s cd cs = let s4 = s
  in s4 `seq` (let s2 = leftSupply s4
                   s3 = rightSupply s4
  in s2 `seq` (s3 `seq` (let x2 = let s1 = leftSupply s2
                                      s0 = rightSupply s2
                               in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply
                               (Curry_Prelude.nd_C_concatMap (wrapDX id
                               d_OP_ppTVarIndex_dot_uscore_hash_lambda9) s0 cd
                               cs) (Curry_Prelude.d_C_enumFrom
                               (Curry_Prelude.C_Int 0#) cd cs) s1 cd cs)
  in Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
  (Curry_Prelude.d_OP_bang_bang x2 x1 cd cs) s3 cd cs)))

d_OP_ppTVarIndex_dot_uscore_hash_lambda9 :: Curry_Prelude.C_Int -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_ppTVarIndex_dot_uscore_hash_lambda9 x1 cd cs = Curry_Prelude.d_C_map
  (d_OP_ppTVarIndex_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1)
  (Curry_Prelude.d_C_enumFromTo (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char
  'a'#) cd cs) (Curry_Prelude.d_C_ord (Curry_Prelude.C_Char 'z'#) cd cs) cd cs)
  cd cs

d_OP_ppTVarIndex_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 :: Curry_Prelude.C_Int
  -> Curry_Prelude.C_Int -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_ppTVarIndex_dot_uscore_hash_lambda9_dot_uscore_hash_lambda10 x1 x2 cd cs =
  Curry_Prelude.OP_Cons (Curry_Prelude.d_C_chr x2 cd cs) (d_C__case_30 x1
  (Curry_Prelude.d_OP_eq_eq x1 (Curry_Prelude.C_Int 0#) cd cs) cd cs)

d_C_ppFuncDecls :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_Prelude.OP_List (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppFuncDecls cd cs = Curry_Prelude.d_OP_dot (Curry_Pretty.d_C_compose
  (Curry_Pretty.d_OP_lt_dollar_plus_dollar_gt cd cs)) (Curry_Prelude.d_C_map
  d_C_ppFuncDecl) cd cs

nd_C_ppFuncDecls :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0)) Curry_Pretty.C_Doc
nd_C_ppFuncDecls s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Pretty.nd_C_compose (Curry_Pretty.nd_OP_lt_dollar_plus_dollar_gt s0 cd
  cs))) (wrapNX id (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppFuncDecl))) s1 cd
  cs))

d_C_ppFuncDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppFuncDecl x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_dollar_dollar_gt cd cs)
    (Curry_Prelude.d_C_apply (d_C_indent cd cs) (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x2 cd
    cs) (Curry_Prelude.OP_Cons (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "::") cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (d_C_ppTypeExp cd cs) x5 cd cs)
    Curry_Prelude.OP_List))) cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_indent cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixOp x2 cd cs) cd cs)
    (d_C_ppRule x6 cd cs) cd cs) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (d_C_ppFuncDecl l cd cs) (d_C_ppFuncDecl r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> d_C_ppFuncDecl z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (d_C_ppFuncDecl e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppFuncDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppFuncDecl" (showCons
    x1))

nd_C_ppFuncDecl :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AFuncDecl t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppFuncDecl x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_AFunc x2 x3 x4 x5 x6 -> let s33 = s
    in s33 `seq` (let s32 = leftSupply s33
                      s34 = rightSupply s33
                      s17 = leftSupply s34
                      s30 = rightSupply s34
    in s32 `seq` (s34 `seq` (s17 `seq` (s30 `seq` Curry_Prelude.nd_C_apply
    (let s16 = leftSupply s17
         s18 = rightSupply s17
         s0 = leftSupply s18
         s14 = rightSupply s18
    in s16 `seq` (s18 `seq` (s0 `seq` (s14 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_dollar_dollar_gt s0 cd cs) (let s13 = leftSupply s14
                                                           s15 = rightSupply s14
                                                           s1 = leftSupply s15
                                                           s11 = rightSupply s15
    in s13 `seq` (s15 `seq` (s1 `seq` (s11 `seq` Curry_Prelude.nd_C_apply
    (nd_C_indent s1 cd cs) (let s10 = leftSupply s11
                                s12 = rightSupply s11
                                s2 = leftSupply s12
                                s9 = rightSupply s12
    in s10 `seq` (s12 `seq` (s2 `seq` (s9 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s2 cd cs) (let s3 = leftSupply s9
                                          s8 = rightSupply s9
    in s3 `seq` (s8 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x2 s3 cd cs)
    (let s4 = leftSupply s8
         s7 = rightSupply s8
    in s4 `seq` (s7 `seq` Curry_Prelude.OP_Cons (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "::") s4 cd cs) (Curry_Prelude.OP_Cons
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp s5 cd cs) x5
    s6 cd cs)) Curry_Prelude.OP_List))))) s10 cd cs)))) s13 cd cs)))) s16 cd
    cs)))) (let s29 = leftSupply s30
                s31 = rightSupply s30
                s19 = leftSupply s31
                s27 = rightSupply s31
    in s29 `seq` (s31 `seq` (s19 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (nd_C_indent s19 cd cs) (let s26 = leftSupply s27
                                 s28 = rightSupply s27
                                 s23 = leftSupply s28
                                 s25 = rightSupply s28
    in s26 `seq` (s28 `seq` (s23 `seq` (s25 `seq` Curry_Prelude.nd_C_apply
    (let s22 = leftSupply s23
         s24 = rightSupply s23
         s20 = leftSupply s24
         s21 = rightSupply s24
    in s22 `seq` (s24 `seq` (s20 `seq` (s21 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s20 cd cs) (nd_C_ppPrefixOp x2 s21 cd cs) s22
    cd cs)))) (nd_C_ppRule x6 s25 cd cs) s26 cd cs)))) s29 cd cs)))) s32 cd
    cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_AFuncDecl d i l r -> narrow d i
    (nd_C_ppFuncDecl l s cd cs) (nd_C_ppFuncDecl r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AFuncDecl d i xs -> narrows cs d i
    (\z -> nd_C_ppFuncDecl z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AFuncDecl d c e -> guardCons d c
    (nd_C_ppFuncDecl e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AFuncDecl d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppFuncDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppFuncDecl" (showCons
    x1))

d_C_ppRule :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_ARule t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppRule x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> d_C__case_29 x3 x4
    (Curry_Prelude.d_C_null x3 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "external") cd cs) cd
    cs) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_dquotes cd cs)
    (Curry_Pretty.d_C_text x6 cd cs) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (d_C_ppRule l cd cs) (d_C_ppRule r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> d_C_ppRule z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (d_C_ppRule e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppRule" (showCons x1))

nd_C_ppRule :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_ARule t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppRule x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ARule x2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_29 x3 x4 (Curry_Prelude.d_C_null x3 cd cs) s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_AExternal x5 x6 -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s3 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "external") s1 cd cs) s2 cd cs))))
    (let s7 = leftSupply s8
         s9 = rightSupply s8
         s5 = leftSupply s9
         s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_dquotes s5 cd cs) (Curry_Pretty.nd_C_text x6 s6 cd cs) s7
    cd cs)))) s10 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_ARule d i l r -> narrow d i
    (nd_C_ppRule l s cd cs) (nd_C_ppRule r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ARule d i xs -> narrows cs d i
    (\z -> nd_C_ppRule z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ARule d c e -> guardCons d c
    (nd_C_ppRule e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ARule d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppRule" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppRule" (showCons x1))

d_C_ppExp :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppExp cd cs = d_C_ppExpr (Curry_Prelude.C_Int 0#)

nd_C_ppExp :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (FlatCurry.Annotated.Curry_Types.C_AExpr t0)
  Curry_Pretty.C_Doc
nd_C_ppExp s cd cs = wrapNX id (nd_C_ppExpr (Curry_Prelude.C_Int 0#))

d_C_ppExpr :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppExpr x1 x2 cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_AVar x3 x4 -> d_C_ppVarIndex x4 cd cs
  FlatCurry.Annotated.Curry_Types.C_ALit x5 x6 -> d_C_ppLiteral x6 cd cs
  FlatCurry.Annotated.Curry_Types.C_AComb x7 x8 x9 x10 -> d_C_ppComb x1 x9 x10
    cd cs
  FlatCurry.Annotated.Curry_Types.C_AFree x11 x12 x13 -> d_C__case_27 x12 x13 x1
    (Curry_Prelude.d_C_null x12 cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ALet x14 x15 x16 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "let") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppDecls cd cs) x15 cd cs) cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "in") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp cd cs) x16 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_AOr x17 x18 x19 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppExpr
    (Curry_Prelude.C_Int 1#) x18 cd cs) cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "?") cd cs) cd cs) cd cs) (d_C_ppExpr
    (Curry_Prelude.C_Int 1#) x19 cd cs) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ACase x20 x21 x22 x23 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_OP_dollar (d_C_indent cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_dollar_dollar_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppCaseType x21 cd cs) cd cs)
    (d_C_ppExpr (Curry_Prelude.C_Int 1#) x22 cd cs) cd cs) cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "of") cd cs) cd cs) cd
    cs) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_vsep cd cs)
    (Curry_Prelude.d_C_map d_C_ppBranch x23 cd cs) cd cs) cd cs) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.C_ATyped x24 x25 x26 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppExp cd cs) x25 cd cs) cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "::") cd cs) cd cs) cd
    cs) (Curry_Prelude.d_C_apply (d_C_ppTypeExp cd cs) x26 cd cs) cd cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (d_C_ppExpr x1 l cd cs) (d_C_ppExpr x1 r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> d_C_ppExpr x1 z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (d_C_ppExpr x1 e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppExpr" (showCons x2))

nd_C_ppExpr :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppExpr x1 x2 s cd cs = case x2 of
  FlatCurry.Annotated.Curry_Types.C_AVar x3 x4 -> let s0 = s
    in s0 `seq` nd_C_ppVarIndex x4 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_ALit x5 x6 -> let s0 = s
    in s0 `seq` nd_C_ppLiteral x6 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_AComb x7 x8 x9 x10 -> let s0 = s
    in s0 `seq` nd_C_ppComb x1 x9 x10 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_AFree x11 x12 x13 -> let s0 = s
    in s0 `seq` nd_C__case_27 x12 x13 x1 (Curry_Prelude.d_C_null x12 cd cs) s0
    cd cs
  FlatCurry.Annotated.Curry_Types.C_ALet x14 x15 x16 -> let s28 = s
    in s28 `seq` (let s27 = leftSupply s28
                      s25 = rightSupply s28
    in s27 `seq` (s25 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s24 = leftSupply s25
                      s26 = rightSupply s25
                      s0 = leftSupply s26
                      s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s0 `seq` (s23 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s10 = leftSupply s23
                                          s21 = rightSupply s23
    in s10 `seq` (s21 `seq` Curry_Prelude.OP_Cons (let s9 = leftSupply s10
                                                       s11 = rightSupply s10
                                                       s4 = leftSupply s11
                                                       s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s4 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "let") s2 cd cs) s3 cd cs))))
    (let s7 = leftSupply s8
         s6 = rightSupply s8
    in s7 `seq` (s6 `seq` Curry_Prelude.nd_C_apply (nd_C_ppDecls s6 cd cs) x15
    s7 cd cs)) s9 cd cs)))) (Curry_Prelude.OP_Cons (let s20 = leftSupply s21
                                                        s22 = rightSupply s21
                                                        s15 = leftSupply s22
                                                        s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s15 `seq` (s19 `seq` Curry_Prelude.nd_C_apply
    (let s14 = leftSupply s15
         s16 = rightSupply s15
         s12 = leftSupply s16
         s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s12 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s12 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "in") s13 cd cs) s14 cd cs))))
    (let s18 = leftSupply s19
         s17 = rightSupply s19
    in s18 `seq` (s17 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s17 cd cs) x16
    s18 cd cs)) s20 cd cs)))) Curry_Prelude.OP_List))) s24 cd cs)))) s27 cd cs))
  FlatCurry.Annotated.Curry_Types.C_AOr x17 x18 x19 -> let s18 = s
    in s18 `seq` (let s17 = leftSupply s18
                      s15 = rightSupply s18
    in s17 `seq` (s15 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s11 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                  s9 = rightSupply s8
                                                  s4 = leftSupply s9
                                                  s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppExpr (Curry_Prelude.C_Int
    1#) x18 s2 cd cs) s3 cd cs)))) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "?") s6 cd cs) s7 cd cs)))) s10 cd cs))))
    (nd_C_ppExpr (Curry_Prelude.C_Int 1#) x19 s13 cd cs) s14 cd cs)))) s17 cd
    cs))
  FlatCurry.Annotated.Curry_Types.C_ACase x20 x21 x22 x23 -> let s34 = s
    in s34 `seq` (let s33 = leftSupply s34
                      s31 = rightSupply s34
    in s33 `seq` (s31 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s30 = leftSupply s31
                      s32 = rightSupply s31
                      s0 = leftSupply s32
                      s28 = rightSupply s32
    in s30 `seq` (s32 `seq` (s0 `seq` (s28 `seq` Curry_Prelude.nd_OP_dollar
    (nd_C_indent s0 cd cs) (let s27 = leftSupply s28
                                s29 = rightSupply s28
                                s20 = leftSupply s29
                                s25 = rightSupply s29
    in s27 `seq` (s29 `seq` (s20 `seq` (s25 `seq` Curry_Prelude.nd_C_apply
    (let s19 = leftSupply s20
         s21 = rightSupply s20
         s1 = leftSupply s21
         s17 = rightSupply s21
    in s19 `seq` (s21 `seq` (s1 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_dollar_dollar_gt s1 cd cs) (let s16 = leftSupply s17
                                                           s18 = rightSupply s17
                                                           s13 = leftSupply s18
                                                           s15 = rightSupply s18
    in s16 `seq` (s18 `seq` (s13 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s12 = leftSupply s13
         s14 = rightSupply s13
         s2 = leftSupply s14
         s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s2 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (let s9 = leftSupply s10
                                                  s11 = rightSupply s10
                                                  s6 = leftSupply s11
                                                  s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s3 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s3 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s3 cd cs) (nd_C_ppCaseType x21 s4 cd cs) s5
    cd cs)))) (nd_C_ppExpr (Curry_Prelude.C_Int 1#) x22 s8 cd cs) s9 cd cs))))
    s12 cd cs)))) (Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "of") s15
    cd cs) s16 cd cs)))) s19 cd cs)))) (let s24 = leftSupply s25
                                            s26 = rightSupply s25
                                            s22 = leftSupply s26
                                            s23 = rightSupply s26
    in s24 `seq` (s26 `seq` (s22 `seq` (s23 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_vsep s22 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppBranch) x23 s23 cd cs) s24 cd cs)))) s27 cd cs)))) s30 cd cs)))) s33
    cd cs))
  FlatCurry.Annotated.Curry_Types.C_ATyped x24 x25 x26 -> let s22 = s
    in s22 `seq` (let s21 = leftSupply s22
                      s19 = rightSupply s22
    in s21 `seq` (s19 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s18 = leftSupply s19
                      s20 = rightSupply s19
                      s13 = leftSupply s20
                      s17 = rightSupply s20
    in s18 `seq` (s20 `seq` (s13 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (let s12 = leftSupply s13
         s14 = rightSupply s13
         s0 = leftSupply s14
         s10 = rightSupply s14
    in s12 `seq` (s14 `seq` (s0 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s9 = leftSupply s10
                                                  s11 = rightSupply s10
                                                  s6 = leftSupply s11
                                                  s8 = rightSupply s11
    in s9 `seq` (s11 `seq` (s6 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s5 = leftSupply s6
         s7 = rightSupply s6
         s1 = leftSupply s7
         s4 = rightSupply s7
    in s5 `seq` (s7 `seq` (s1 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s3 = leftSupply s4
                                                  s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s2 cd cs) x25 s3
    cd cs)) s5 cd cs)))) (Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString
    "::") s8 cd cs) s9 cd cs)))) s12 cd cs)))) (let s16 = leftSupply s17
                                                    s15 = rightSupply s17
    in s16 `seq` (s15 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp s15 cd cs)
    x26 s16 cd cs)) s18 cd cs)))) s21 cd cs))
  FlatCurry.Annotated.Curry_Types.Choice_C_AExpr d i l r -> narrow d i
    (nd_C_ppExpr x1 l s cd cs) (nd_C_ppExpr x1 r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_AExpr d i xs -> narrows cs d i
    (\z -> nd_C_ppExpr x1 z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_AExpr d c e -> guardCons d c
    (nd_C_ppExpr x1 e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_AExpr d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppExpr" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppExpr" (showCons x2))

d_C_ppAVarIndex :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppAVarIndex x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> d_C__case_25 x2 (Curry_Prelude.d_OP_lt x2
    (Curry_Prelude.C_Int 0#) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppAVarIndex l cd cs)
    (d_C_ppAVarIndex r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_ppAVarIndex z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_ppAVarIndex e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppAVarIndex" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppAVarIndex" (showCons
    x1))

nd_C_ppAVarIndex :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppAVarIndex x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s0 = s
    in s0 `seq` nd_C__case_25 x2 (Curry_Prelude.d_OP_lt x2 (Curry_Prelude.C_Int
    0#) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppAVarIndex l s cd
    cs) (nd_C_ppAVarIndex r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_ppAVarIndex z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_ppAVarIndex e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppAVarIndex" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppAVarIndex" (showCons
    x1))

d_C_ppVarIndex :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppVarIndex x1 cd cs = d_C__case_23 x1 (Curry_Prelude.d_OP_lt x1
  (Curry_Prelude.C_Int 0#) cd cs) cd cs

nd_C_ppVarIndex :: Curry_Prelude.C_Int -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C_ppVarIndex x1 s cd cs = let s0 = s
  in s0 `seq` nd_C__case_23 x1 (Curry_Prelude.d_OP_lt x1 (Curry_Prelude.C_Int
  0#) cd cs) s0 cd cs

d_C_ppLiteral :: FlatCurry.Curry_Types.C_Literal -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppLiteral x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> Curry_Pretty.d_C_int x2 cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> Curry_Pretty.d_C_float x3 cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> Curry_Pretty.d_C_text (d_C_showEscape x4
    cd cs) cd cs
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (d_C_ppLiteral l
    cd cs) (d_C_ppLiteral r cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    d_C_ppLiteral z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c (d_C_ppLiteral e
    cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppLiteral" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppLiteral" (showCons
    x1))

nd_C_ppLiteral :: FlatCurry.Curry_Types.C_Literal -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppLiteral x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Intc x2 -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_int x2 s0 cd cs
  FlatCurry.Curry_Types.C_Floatc x3 -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_float x3 s0 cd cs
  FlatCurry.Curry_Types.C_Charc x4 -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (d_C_showEscape x4 cd cs) s0 cd cs
  FlatCurry.Curry_Types.Choice_C_Literal d i l r -> narrow d i (nd_C_ppLiteral l
    s cd cs) (nd_C_ppLiteral r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Literal d i xs -> narrows cs d i (\z ->
    nd_C_ppLiteral z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Literal d c e -> guardCons d c (nd_C_ppLiteral e
    s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Literal d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppLiteral" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppLiteral" (showCons
    x1))

d_C_showEscape :: Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showEscape x1 cd cs = let x2 = Curry_Prelude.d_C_ord x1 cd cs
  in d_C__case_21 x2 x1 (Curry_Prelude.d_OP_lt x2 (Curry_Prelude.C_Int 10#) cd
  cs) cd cs

d_C_ppComb :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppComb x1 x2 x3 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_17 x3 x4 x1
    (Curry_Prelude.d_OP_amp_amp (d_C_isListId x4 cd cs) (Curry_Prelude.d_C_null
    x3 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppComb x1 l x3 cd
    cs) (d_C_ppComb x1 r x3 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppComb x1
    z x3 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_ppComb x1 e x3 cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppComb" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppComb" (showCons x2))

nd_C_ppComb :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) t0 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppComb x1 x2 x3 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> let s0 = s
    in s0 `seq` nd_C__case_17 x3 x4 x1 (Curry_Prelude.d_OP_amp_amp (d_C_isListId
    x4 cd cs) (Curry_Prelude.d_C_null x3 cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppComb x1 l x3 s cd
    cs) (nd_C_ppComb x1 r x3 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppComb x1
    z x3 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_ppComb x1 e x3 s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppComb" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppComb" (showCons x2))

d_C_ppDecls :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Cover -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1)) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppDecls cd cs = Curry_Prelude.d_OP_dot (Curry_Pretty.d_C_semiBracesSpaced cd
  cs) (Curry_Prelude.d_C_map d_C_ppDecl) cd cs

nd_C_ppDecls :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => IDSupply -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1))) Curry_Pretty.C_Doc
nd_C_ppDecls s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot
  (Curry_Pretty.nd_C_semiBracesSpaced s0 cd cs) (wrapNX id
  (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppDecl))) s1 cd cs))

d_C_ppDecl :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  t0) (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppDecl x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppAVarIndex x2 cd cs) cd cs)
    (Curry_Pretty.d_C_equals cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp cd cs) x3 cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppDecl l cd cs)
    (d_C_ppDecl r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppDecl z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_ppDecl e cd $! addCs
    c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppDecl" (showCons x1))

nd_C_ppDecl :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int
  t0) (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppDecl x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s17 = s
    in s17 `seq` (let s16 = leftSupply s17
                      s18 = rightSupply s17
                      s11 = leftSupply s18
                      s15 = rightSupply s18
    in s16 `seq` (s18 `seq` (s11 `seq` (s15 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                  s9 = rightSupply s8
                                                  s4 = leftSupply s9
                                                  s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppAVarIndex x2 s2 cd cs) s3
    cd cs)))) (Curry_Pretty.nd_C_equals s6 cd cs) s7 cd cs)))) s10 cd cs))))
    (let s14 = leftSupply s15
         s13 = rightSupply s15
    in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s13 cd cs) x3
    s14 cd cs)) s16 cd cs))))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppDecl l s cd cs)
    (nd_C_ppDecl r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppDecl z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_ppDecl e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppDecl" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppDecl" (showCons x1))

d_C_ppCaseType :: FlatCurry.Curry_Types.C_CaseType -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppCaseType x1 cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rigid -> Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "case") cd cs
  FlatCurry.Curry_Types.C_Flex -> Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "fcase") cd cs
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (d_C_ppCaseType
    l cd cs) (d_C_ppCaseType r cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    d_C_ppCaseType z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c (d_C_ppCaseType
    e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppCaseType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppCaseType" (showCons
    x1))

nd_C_ppCaseType :: FlatCurry.Curry_Types.C_CaseType -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppCaseType x1 s cd cs = case x1 of
  FlatCurry.Curry_Types.C_Rigid -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "case") s0
    cd cs
  FlatCurry.Curry_Types.C_Flex -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "fcase") s0
    cd cs
  FlatCurry.Curry_Types.Choice_C_CaseType d i l r -> narrow d i (nd_C_ppCaseType
    l s cd cs) (nd_C_ppCaseType r s cd cs)
  FlatCurry.Curry_Types.Choices_C_CaseType d i xs -> narrows cs d i (\z ->
    nd_C_ppCaseType z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_CaseType d c e -> guardCons d c (nd_C_ppCaseType
    e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_CaseType d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppCaseType" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppCaseType" (showCons
    x1))

d_C_ppBranch :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppBranch x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x2 x3 -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPattern x2 cd cs) cd cs)
    (Curry_Pretty.d_C_rarrow cd cs) cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_indent cd cs) (Curry_Prelude.d_C_apply (d_C_ppExp cd cs) x3 cd cs) cd
    cs) cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (d_C_ppBranch l cd cs) (d_C_ppBranch r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> d_C_ppBranch z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (d_C_ppBranch e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppBranch" (showCons
    x1))

nd_C_ppBranch :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_ABranchExpr t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppBranch x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_ABranch x2 x3 -> let s21 = s
    in s21 `seq` (let s20 = leftSupply s21
                      s22 = rightSupply s21
                      s11 = leftSupply s22
                      s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s11 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                  s9 = rightSupply s8
                                                  s4 = leftSupply s9
                                                  s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppPattern x2 s2 cd cs) s3 cd
    cs)))) (Curry_Pretty.nd_C_rarrow s6 cd cs) s7 cd cs)))) s10 cd cs))))
    (let s17 = leftSupply s18
         s19 = rightSupply s18
         s13 = leftSupply s19
         s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s13 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (nd_C_indent s13 cd cs) (let s15 = leftSupply s16
                                 s14 = rightSupply s16
    in s15 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s14 cd cs) x3
    s15 cd cs)) s17 cd cs)))) s20 cd cs))))
  FlatCurry.Annotated.Curry_Types.Choice_C_ABranchExpr d i l r -> narrow d i
    (nd_C_ppBranch l s cd cs) (nd_C_ppBranch r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_ABranchExpr d i xs -> narrows cs d i
    (\z -> nd_C_ppBranch z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_ABranchExpr d c e -> guardCons d c
    (nd_C_ppBranch e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_ABranchExpr d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppBranch" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppBranch" (showCons
    x1))

d_C_ppPattern :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_ppPattern x1 cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_APattern x2 x3 x4 -> d_C__case_10 x4 x3 cd
    cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x13 x14 -> d_C_ppLiteral x14 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (d_C_ppPattern l cd cs) (d_C_ppPattern r cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> d_C_ppPattern z cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (d_C_ppPattern e cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppPattern" (showCons
    x1))

nd_C_ppPattern :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_APattern t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppPattern x1 s cd cs = case x1 of
  FlatCurry.Annotated.Curry_Types.C_APattern x2 x3 x4 -> let s0 = s
    in s0 `seq` nd_C__case_10 x4 x3 s0 cd cs
  FlatCurry.Annotated.Curry_Types.C_ALPattern x13 x14 -> let s0 = s
    in s0 `seq` nd_C_ppLiteral x14 s0 cd cs
  FlatCurry.Annotated.Curry_Types.Choice_C_APattern d i l r -> narrow d i
    (nd_C_ppPattern l s cd cs) (nd_C_ppPattern r s cd cs)
  FlatCurry.Annotated.Curry_Types.Choices_C_APattern d i xs -> narrows cs d i
    (\z -> nd_C_ppPattern z s cd cs) xs
  FlatCurry.Annotated.Curry_Types.Guard_C_APattern d c e -> guardCons d c
    (nd_C_ppPattern e s cd $! addCs c cs)
  FlatCurry.Annotated.Curry_Types.Fail_C_APattern d info -> failCons d
    (traceFail "FlatCurry.Annotated.Pretty.ppPattern" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppPattern" (showCons
    x1))

d_C_ppPrefixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppPrefixOp x1 cd cs = Curry_Pretty.d_C_parensIf (Curry_Prelude.d_C_apply
  (d_C_isInfixOp cd cs) x1 cd cs) (d_C_ppQName x1 cd cs) cd cs

nd_C_ppPrefixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppPrefixOp x1 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Pretty.nd_C_parensIf
  (Curry_Prelude.nd_C_apply (wrapDX id (d_C_isInfixOp cd cs)) x1 s0 cd cs)
  (nd_C_ppQName x1 s1 cd cs) s2 cd cs))))

d_C_ppInfixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppInfixOp x1 cd cs = d_C__case_2 x1 (Curry_Prelude.d_C_apply (d_C_isInfixOp
  cd cs) x1 cd cs) cd cs

nd_C_ppInfixOp :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppInfixOp x1 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_2 x1 (Curry_Prelude.nd_C_apply (wrapDX id
  (d_C_isInfixOp cd cs)) x1 s0 cd cs) s1 cd cs))

d_C_ppQName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C_ppQName x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let x4 = Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "[]")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "?")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString ":")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "+")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "-")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "*")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "<")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString ">")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "<=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString ">=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "==")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "/=")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "&>")
                                         (Curry_Prelude.OP_Cons
                                         (Curry_Prelude.toCurryString "&")
                                         Curry_Prelude.OP_List)))))))))))))
    in d_C__case_1 x4 x3 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.toCurryString "Prelude") cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x3 cd cs) x4 cd cs) cd cs)
    cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_ppQName l cd cs)
    (d_C_ppQName r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_ppQName z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_ppQName e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppQName" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppQName" (showCons x1))

nd_C_ppQName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C_ppQName x1 s cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> let s2 = s
    in s2 `seq` (let x4 = Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "[]") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "?") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       ":") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "+") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "-") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "*") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "<") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       ">") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "<=") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       ">=") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "==") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "/=") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "&>") (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString
                       "&") Curry_Prelude.OP_List)))))))))))))
    in let s1 = leftSupply s2
           s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_1 x4 x3 x2 (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_eq_eq x2 (Curry_Prelude.toCurryString "Prelude") cd cs)
    (Curry_Prelude.nd_C_apply (wrapDX id (Curry_Prelude.d_C_elem x3 cd cs)) x4
    s0 cd cs) cd cs) s1 cd cs))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_ppQName l s cd cs)
    (nd_C_ppQName r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C_ppQName z
    s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_ppQName e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.ppQName" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.ppQName" (showCons x1))

d_C_isInfixOp :: Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isInfixOp cd cs = Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_all
  (Curry_Prelude.d_C_flip Curry_Prelude.d_C_elem (Curry_Prelude.toCurryString
  "~!@#$%^&*+-=<>:?./|\\")) cd cs) Curry_Prelude.d_C_snd cd cs

d_C_isListId :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isListId x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x2 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_eq_eq x3 (Curry_Prelude.toCurryString "[]") cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_isListId l cd cs)
    (d_C_isListId r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_isListId z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_isListId e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.isListId" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.isListId" (showCons
    x1))

d_C_isTupleId :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_isTupleId x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_elem x2 cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.toCurryString "Prelude")
    (Curry_Prelude.OP_Cons Curry_Prelude.OP_List Curry_Prelude.OP_List)) cd cs)
    (Curry_Prelude.d_OP_eq_eq x3 (d_OP_isTupleId_dot_mkTuple_dot_199
    (Curry_Prelude.d_C_length x3 cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_isTupleId l cd cs)
    (d_C_isTupleId r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C_isTupleId
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_isTupleId e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty.isTupleId" [show x1] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty.isTupleId" (showCons
    x1))

d_OP_isTupleId_dot_mkTuple_dot_199 :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_isTupleId_dot_mkTuple_dot_199 x1 cd cs = Curry_Prelude.OP_Cons
  (Curry_Prelude.C_Char '('#) (Curry_Prelude.d_OP_plus_plus
  (Curry_Prelude.d_C_replicate (Curry_Prelude.d_OP_minus x1 (Curry_Prelude.C_Int
  2#) cd cs) (Curry_Prelude.C_Char ','#) cd cs) (Curry_Prelude.toCurryString
  ")") cd cs)

d_C_indent :: Cover -> ConstStore -> Curry_Pretty.C_Doc -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C_indent cd cs = Curry_Pretty.d_C_nest (Curry_Prelude.C_Int 2#)

nd_C_indent :: IDSupply -> Cover -> ConstStore -> Func Curry_Pretty.C_Doc
  Curry_Pretty.C_Doc
nd_C_indent s cd cs = wrapNX id (Curry_Pretty.nd_C_nest (Curry_Prelude.C_Int
  2#))

d_C__case_1 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_1 x4 x3 x2 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Pretty.d_C_text x3 cd cs
  Curry_Prelude.C_False -> d_C__case_0 x3 x2 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x4 x3 x2 l cd
    cs) (d_C__case_1 x4 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x4 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_1 x4 x3 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_1" [show x4, show x3, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_1" (showCons x5))

nd_C__case_1 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_1 x4 x3 x2 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text x3 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_0 x3 x2 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_1 x4 x3 x2 l s
    cd cs) (nd_C__case_1 x4 x3 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_1 x4
    x3 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_1 x4 x3 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_1" [show x4, show x3, show x2, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_1" (showCons x5))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_0 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '.'#) x3) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x3 x2 l cd cs)
    (d_C__case_0 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x3 x2
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_0 x3 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_0" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_0" (showCons x4))

nd_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_0 x3 x2 x4 s cd cs = case x4 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.OP_Cons
    (Curry_Prelude.C_Char '.'#) x3) cd cs) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_0 x3 x2 l s cd
    cs) (nd_C__case_0 x3 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_0 x3
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_0 x3 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_0" [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_0" (showCons x4))

d_C__case_2 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_2 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> d_C_ppQName x1 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_bquotes cd
    cs) (d_C_ppQName x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x1 l cd cs)
    (d_C__case_2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_2" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_2" (showCons x2))

nd_C__case_2 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_2 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppQName x1 s0 cd cs
  Curry_Prelude.C_False -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_bquotes s0 cd cs) (nd_C_ppQName x1 s1 cd cs) s2 cd cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_2 x1 l s cd cs)
    (nd_C__case_2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_2 x1 z
    s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_2 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_2" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_2" (showCons x2))

d_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_10 x4 x3 cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_9 x4 x5 (Curry_Prelude.d_OP_amp_amp
    (d_C_isListId x5 cd cs) (Curry_Prelude.d_C_null x4 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_10 x4 l cd cs)
    (d_C__case_10 x4 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_10
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C__case_10 x4 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_10" [show x4, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_10" (showCons
    x3))

nd_C__case_10 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_10 x4 x3 s cd cs = case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_9 x4 x5 (Curry_Prelude.d_OP_amp_amp (d_C_isListId x5
    cd cs) (Curry_Prelude.d_C_null x4 cd cs) cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C__case_10 x4 l s cd
    cs) (nd_C__case_10 x4 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> nd_C__case_10
    x4 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C__case_10 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_10" [show x4, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_10" (showCons
    x3))

d_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_9 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Pretty.d_C_text (Curry_Prelude.toCurryString
    "[]") cd cs
  Curry_Prelude.C_False -> d_C__case_8 x5 x4 (d_C_isTupleId x5 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x4 x5 l cd cs)
    (d_C__case_9 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x4 x5
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_9 x4 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_9" [show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_9" (showCons x6))

nd_C__case_9 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_9 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "[]") s0 cd
    cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_8 x5 x4 (d_C_isTupleId x5 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_9 x4 x5 l s cd
    cs) (nd_C__case_9 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_9 x4
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_9 x4 x5 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_9" [show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_9" (showCons x6))

d_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_8 x5 x4 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_tupled cd
    cs) (Curry_Prelude.d_C_map d_C_ppAVarIndex x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_7 x4 x5 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x5 x4 l cd cs)
    (d_C__case_8 x5 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x5 x4
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_8 x5 x4 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_8" [show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_8" (showCons x6))

nd_C__case_8 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_8 x5 x4 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_tupled s0 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppAVarIndex) x4 s1 cd cs) s2 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_7 x4 x5 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_8 x5 x4 l s cd
    cs) (nd_C__case_8 x5 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_8 x5
    x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_8 x5 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_8" [show x5, show x4, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_8" (showCons x6))

d_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_7 x4 x5 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C__case_6 x5 x4 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x4 x5 l cd cs)
    (d_C__case_7 x4 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x4 x5
    z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_7 x4 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_7" [show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_7" (showCons x6))

nd_C__case_7 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_7 x4 x5 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C__case_6 x5 x4 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x4 x5 l s cd
    cs) (nd_C__case_7 x4 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x4
    x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_7 x4 x5 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_7" [show x4, show x5, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_7" (showCons x6))

d_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_6 x5 x4 cd cs = case x4 of
  Curry_Prelude.OP_Cons x7 x8 -> d_C__case_5 x4 x5 x7 x8 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x5 cd cs) (Curry_Prelude.d_C_map
    d_C_ppAVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_6 x5 l cd cs)
    (d_C__case_6 x5 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_6 x5 z
    cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_6 x5 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_6" [show x5, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_6" (showCons x4))

nd_C__case_6 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_6 x5 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Cons x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_5 x4 x5 x7 x8 s0 cd cs
  Curry_Prelude.OP_List -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x5 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppAVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_6 x5 l s cd cs)
    (nd_C__case_6 x5 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_6 x5
    z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_6 x5 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_6" [show x5, show x4] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_6" (showCons x4))

d_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_5 x4 x5 x7 x8 cd cs = case x8 of
  Curry_Prelude.OP_Cons x9 x10 -> d_C__case_4 x4 x5 x9 x7 x10 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x5 cd cs) (Curry_Prelude.d_C_map
    d_C_ppAVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_5 x4 x5 x7 l cd
    cs) (d_C__case_5 x4 x5 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_5 x4
    x5 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_5 x4 x5 x7 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_5" [show x4, show x5, show x7, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_5" (showCons x8))

nd_C__case_5 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_5 x4 x5 x7 x8 s cd cs = case x8 of
  Curry_Prelude.OP_Cons x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_4 x4 x5 x9 x7 x10 s0 cd cs
  Curry_Prelude.OP_List -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x5 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppAVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_5 x4 x5 x7 l s
    cd cs) (nd_C__case_5 x4 x5 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_5 x4
    x5 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_5 x4 x5 x7 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_5" [show x4, show x5, show x7, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_5" (showCons x8))

d_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_4 x4 x5 x9 x7 x10 cd cs = case x10 of
  Curry_Prelude.OP_List -> d_C__case_3 x5 x4 x9 x7 (Curry_Prelude.d_C_apply
    (d_C_isInfixOp cd cs) x5 cd cs) cd cs
  Curry_Prelude.OP_Cons x11 x12 -> Curry_Prelude.d_C_apply
    (Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x5 cd
    cs) (Curry_Prelude.d_C_map d_C_ppAVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_4 x4 x5 x9 x7 l
    cd cs) (d_C__case_4 x4 x5 x9 x7 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_4 x4
    x5 x9 x7 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_4 x4 x5 x9 x7 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_4" [show x4, show x5, show x9, show x7
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_4" (showCons
    x10))

nd_C__case_4 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_4 x4 x5 x9 x7 x10 s cd cs = case x10 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_3 x5 x4 x9 x7 (Curry_Prelude.nd_C_apply
    (wrapDX id (d_C_isInfixOp cd cs)) x5 s0 cd cs) s1 cd cs))
  Curry_Prelude.OP_Cons x11 x12 -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x5 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppAVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_4 x4 x5 x9 x7 l
    s cd cs) (nd_C__case_4 x4 x5 x9 x7 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_4 x4
    x5 x9 x7 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_4 x4 x5 x9 x7 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_4" [show x4, show x5, show x9, show x7
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_4" (showCons
    x10))

d_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_3 x5 x4 x9 x7 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (d_C_ppAVarIndex x7 cd cs) cd cs) (d_C_ppInfixOp x5 cd cs) cd cs) cd cs)
    (d_C_ppAVarIndex x9 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_hsep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x5 cd cs) (Curry_Prelude.d_C_map
    d_C_ppAVarIndex x4 cd cs)) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_3 x5 x4 x9 x7 l
    cd cs) (d_C__case_3 x5 x4 x9 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_3 x5 x4
    x9 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_3 x5 x4 x9 x7 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_3" [show x5, show x4, show x9, show x7
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_3" (showCons
    x10))

nd_C__case_3 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  Curry_Prelude.C_Int t0) -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_3 x5 x4 x9 x7 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s15 = s
    in s15 `seq` (let s14 = leftSupply s15
                      s16 = rightSupply s15
                      s11 = leftSupply s16
                      s13 = rightSupply s16
    in s14 `seq` (s16 `seq` (s11 `seq` (s13 `seq` Curry_Prelude.nd_C_apply
    (let s10 = leftSupply s11
         s12 = rightSupply s11
         s0 = leftSupply s12
         s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s0 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (let s7 = leftSupply s8
                                                  s9 = rightSupply s8
                                                  s4 = leftSupply s9
                                                  s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s4 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (let s3 = leftSupply s4
         s5 = rightSupply s4
         s1 = leftSupply s5
         s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (nd_C_ppAVarIndex x7 s2 cd cs) s3
    cd cs)))) (nd_C_ppInfixOp x5 s6 cd cs) s7 cd cs)))) s10 cd cs))))
    (nd_C_ppAVarIndex x9 s13 cd cs) s14 cd cs))))
  Curry_Prelude.C_False -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s0 cd cs) (let s1 = leftSupply s3
                                           s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x5 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppAVarIndex) x4 s2 cd cs))) s4 cd
    cs))))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_3 x5 x4 x9 x7 l
    s cd cs) (nd_C__case_3 x5 x4 x9 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_3 x5
    x4 x9 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_3 x5 x4 x9 x7 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_3" [show x5, show x4, show x9, show x7
    , show x10] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_3" (showCons
    x10))

d_C__case_17 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_17 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Pretty.d_C_text (Curry_Prelude.toCurryString
    "[]") cd cs
  Curry_Prelude.C_False -> d_C__case_16 x4 x3 x1 (d_C_isTupleId x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x3 x4 x1 l cd
    cs) (d_C__case_17 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_17 x3 x4 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_17" [show x3, show x4, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_17" (showCons
    x5))

nd_C__case_17 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_17 x3 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "[]") s0 cd
    cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_16 x4 x3 x1 (d_C_isTupleId x4 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x3 x4 x1 l s
    cd cs) (nd_C__case_17 x3 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x3
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_17 x3 x4 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_17" [show x3, show x4, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_17" (showCons
    x5))

d_C__case_16 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_16 x4 x3 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_tupled cd
    cs) (Curry_Prelude.d_C_map (d_C_ppExp cd cs) x3 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_15 x3 x4 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x4 x3 x1 l cd
    cs) (d_C__case_16 x4 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x4
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_16 x4 x3 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_16" [show x4, show x3, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_16" (showCons
    x5))

nd_C__case_16 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_16 x4 x3 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_tupled s0 cd cs) (let s2 = leftSupply s3
                                             s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_ppExp s1 cd cs) x3 s2 cd
    cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_15 x3 x4 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_16 x4 x3 x1 l s
    cd cs) (nd_C__case_16 x4 x3 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_16 x4
    x3 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_16 x4 x3 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_16" [show x4, show x3, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_16" (showCons
    x5))

d_C__case_15 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_15 x3 x4 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C__case_14 x4 x1 x3 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x3 x4 x1 l cd
    cs) (d_C__case_15 x3 x4 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x3
    x4 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_15 x3 x4 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_15" [show x3, show x4, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_15" (showCons
    x5))

nd_C__case_15 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_15 x3 x4 x1 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C__case_14 x4 x1 x3 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_15 x3 x4 x1 l s
    cd cs) (nd_C__case_15 x3 x4 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_15 x3
    x4 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_15 x3 x4 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_15" [show x3, show x4, show x1, show x5]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_15" (showCons
    x5))

d_C__case_14 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_14 x4 x1 x3 cd cs = case x3 of
  Curry_Prelude.OP_List -> d_C_ppPrefixOp x4 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> d_C__case_13 x3 x4 x1 x6 x7 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_14 x4 x1 l cd
    cs) (d_C__case_14 x4 x1 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_14 x4
    x1 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_14 x4 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_14" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_14" (showCons
    x3))

nd_C__case_14 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_14 x4 x1 x3 s cd cs = case x3 of
  Curry_Prelude.OP_List -> let s0 = s in s0 `seq` nd_C_ppPrefixOp x4 s0 cd cs
  Curry_Prelude.OP_Cons x6 x7 -> let s0 = s
    in s0 `seq` nd_C__case_13 x3 x4 x1 x6 x7 s0 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_14 x4 x1 l s cd
    cs) (nd_C__case_14 x4 x1 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_14 x4
    x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_14 x4 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_14" [show x4, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_14" (showCons
    x3))

d_C__case_13 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_13 x3 x4 x1 x6 x7 cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> d_C__case_12 x3 x4 x1 x8 x6 x9 cd cs
  Curry_Prelude.OP_List -> Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_parensIf
    (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int 0#) cd cs))
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppPrefixOp x4 cd cs) (Curry_Prelude.d_C_map (d_C_ppExpr
    (Curry_Prelude.C_Int 1#)) x3 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_13 x3 x4 x1 x6 l
    cd cs) (d_C__case_13 x3 x4 x1 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_13 x3
    x4 x1 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_13 x3 x4 x1 x6 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_13" [show x3, show x4, show x1, show x6
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_13" (showCons
    x7))

nd_C__case_13 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_13 x3 x4 x1 x6 x7 s cd cs = case x7 of
  Curry_Prelude.OP_Cons x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_12 x3 x4 x1 x8 x6 x9 s0 cd cs
  Curry_Prelude.OP_List -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s4 = leftSupply s5
                      s6 = rightSupply s5
                      s0 = leftSupply s6
                      s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s1 = leftSupply s3
                                          s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x4 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr (Curry_Prelude.C_Int 1#)))
    x3 s2 cd cs))) s4 cd cs)))) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_13 x3 x4 x1 x6
    l s cd cs) (nd_C__case_13 x3 x4 x1 x6 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_13 x3
    x4 x1 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_13 x3 x4 x1 x6
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_13" [show x3, show x4, show x1, show x6
    , show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_13" (showCons
    x7))

d_C__case_12 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_12 x3 x4 x1 x8 x6 x9 cd cs = case x9 of
  Curry_Prelude.OP_List -> d_C__case_11 x4 x3 x1 x8 x6 (Curry_Prelude.d_C_apply
    (d_C_isInfixOp cd cs) x4 cd cs) cd cs
  Curry_Prelude.OP_Cons x10 x11 -> Curry_Prelude.d_OP_dollar
    (Curry_Pretty.d_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs)) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x4 cd cs) (Curry_Prelude.d_C_map
    (d_C_ppExpr (Curry_Prelude.C_Int 1#)) x3 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_12 x3 x4 x1 x8
    x6 l cd cs) (d_C__case_12 x3 x4 x1 x8 x6 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_12 x3
    x4 x1 x8 x6 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (d_C__case_12 x3 x4 x1 x8
    x6 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_12" [show x3, show x4, show x1, show x8
    , show x6, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_12" (showCons
    x9))

nd_C__case_12 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_12 x3 x4 x1 x8 x6 x9 s cd cs = case x9 of
  Curry_Prelude.OP_List -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C__case_11 x4 x3 x1 x8 x6 (Curry_Prelude.nd_C_apply
    (wrapDX id (d_C_isInfixOp cd cs)) x4 s0 cd cs) s1 cd cs))
  Curry_Prelude.OP_Cons x10 x11 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s4 = leftSupply s5
                      s6 = rightSupply s5
                      s0 = leftSupply s6
                      s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s1 = leftSupply s3
                                          s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x4 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr (Curry_Prelude.C_Int 1#)))
    x3 s2 cd cs))) s4 cd cs)))) s7 cd cs))
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (nd_C__case_12 x3 x4 x1 x8
    x6 l s cd cs) (nd_C__case_12 x3 x4 x1 x8 x6 r s cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> nd_C__case_12 x3
    x4 x1 x8 x6 z s cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c (nd_C__case_12 x3 x4 x1 x8
    x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_12" [show x3, show x4, show x1, show x8
    , show x6, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_12" (showCons
    x9))

d_C__case_11 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_11 x4 x3 x1 x8 x6 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_parensIf
    (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int 0#) cd cs))
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppExpr (Curry_Prelude.C_Int 1#) x6 cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppInfixOp x4 cd cs) (Curry_Prelude.OP_Cons (d_C_ppExpr
    (Curry_Prelude.C_Int 1#) x8 cd cs) Curry_Prelude.OP_List))) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_parensIf
    (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int 0#) cd cs))
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
    (d_C_ppPrefixOp x4 cd cs) (Curry_Prelude.d_C_map (d_C_ppExpr
    (Curry_Prelude.C_Int 1#)) x3 cd cs)) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x4 x3 x1 x8 x6
    l cd cs) (d_C__case_11 x4 x3 x1 x8 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x4
    x3 x1 x8 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_11 x4 x3 x1 x8 x6
    e cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_11" [show x4, show x3, show x1, show x8
    , show x6, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_11" (showCons
    x9))

nd_C__case_11 :: forall t1 . (Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (FlatCurry.Annotated.Curry_Types.C_AExpr t1) -> Curry_Prelude.C_Int
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t1 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_11 x4 x3 x1 x8 x6 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s10 = s
    in s10 `seq` (let s9 = leftSupply s10
                      s7 = rightSupply s10
    in s9 `seq` (s7 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s6 = leftSupply s7
                      s8 = rightSupply s7
                      s0 = leftSupply s8
                      s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s1 = leftSupply s5
                                          s4 = rightSupply s5
    in s1 `seq` (s4 `seq` Curry_Prelude.OP_Cons (nd_C_ppExpr
    (Curry_Prelude.C_Int 1#) x6 s1 cd cs) (let s2 = leftSupply s4
                                               s3 = rightSupply s4
    in s2 `seq` (s3 `seq` Curry_Prelude.OP_Cons (nd_C_ppInfixOp x4 s2 cd cs)
    (Curry_Prelude.OP_Cons (nd_C_ppExpr (Curry_Prelude.C_Int 1#) x8 s3 cd cs)
    Curry_Prelude.OP_List))))) s6 cd cs)))) s9 cd cs))
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s4 = leftSupply s5
                      s6 = rightSupply s5
                      s0 = leftSupply s6
                      s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s1 = leftSupply s3
                                          s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x4 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppExpr (Curry_Prelude.C_Int 1#)))
    x3 s2 cd cs))) s4 cd cs)))) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_11 x4 x3 x1 x8
    x6 l s cd cs) (nd_C__case_11 x4 x3 x1 x8 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_11 x4
    x3 x1 x8 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_11 x4 x3 x1 x8
    x6 e s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_11" [show x4, show x3, show x1, show x8
    , show x6, show x9] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_11" (showCons
    x9))

d_C__case_21 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_21 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "'\\00") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.toCurryString "'") cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_20 x2 x1 (Curry_Prelude.d_OP_lt x2
    (Curry_Prelude.C_Int 32#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x2 x1 l cd cs)
    (d_C__case_21 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_21 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_21" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_21" (showCons
    x3))

d_C__case_20 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_20 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "'\\0") (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.toCurryString "'") cd cs)
    cd cs
  Curry_Prelude.C_False -> d_C__case_19 x2 x1 (Curry_Prelude.d_OP_eq_eq x2
    (Curry_Prelude.C_Int 127#) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_20 x2 x1 l cd cs)
    (d_C__case_20 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_20 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_20 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_20" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_20" (showCons
    x3))

d_C__case_19 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_19 x2 x1 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.toCurryString "'\\127'"
  Curry_Prelude.C_False -> d_C__case_18 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_19 x2 x1 l cd cs)
    (d_C__case_19 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_19 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_19 x2 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_19" [show x2, show x1, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_19" (showCons
    x3))

d_C__case_18 :: Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_18 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_show x1 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_18 x1 l cd cs)
    (d_C__case_18 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_18 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_18 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_18" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_18" (showCons
    x2))

d_C__case_23 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_23 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.d_C_show
    (Curry_Prelude.d_C_negate x1 cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C__case_22 x1 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_23 x1 l cd cs)
    (d_C__case_23 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_23 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_23 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_23" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_23" (showCons
    x2))

nd_C__case_23 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_23 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.d_C_show
    (Curry_Prelude.d_C_negate x1 cd cs) cd cs)) s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_22 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_23 x1 l s cd cs)
    (nd_C__case_23 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_23 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_23 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_23" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_23" (showCons
    x2))

d_C__case_22 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_22 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.d_C_show
    x1 cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x1 l cd cs)
    (d_C__case_22 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_22 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_22" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_22" (showCons
    x2))

nd_C__case_22 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_22 x1 x2 s cd cs = case x2 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.d_C_show
    x1 cd cs)) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_22 x1 l s cd cs)
    (nd_C__case_22 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_22 x1
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_22 x1 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_22" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_22" (showCons
    x2))

d_C__case_25 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_25 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.d_C_show
    (Curry_Prelude.d_C_negate x2 cd cs) cd cs)) cd cs
  Curry_Prelude.C_False -> d_C__case_24 x2 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x2 l cd cs)
    (d_C__case_25 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_25 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_25" [show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_25" (showCons
    x3))

nd_C__case_25 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_25 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'x'#) (Curry_Prelude.d_C_show
    (Curry_Prelude.d_C_negate x2 cd cs) cd cs)) s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_24 x2 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_25 x2 l s cd cs)
    (nd_C__case_25 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_25 x2
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_25 x2 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_25" [show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_25" (showCons
    x3))

d_C__case_24 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_24 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar Curry_Pretty.d_C_text
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.d_C_show
    x2 cd cs)) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x2 l cd cs)
    (d_C__case_24 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x2 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_24 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_24" [show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_24" (showCons
    x3))

nd_C__case_24 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_24 x2 x3 s cd cs = case x3 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id Curry_Pretty.nd_C_text)
    (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.d_C_show
    x2 cd cs)) s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_24 x2 l s cd cs)
    (nd_C__case_24 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_24 x2
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_24 x2 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_24" [show x2, show x3] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_24" (showCons
    x3))

d_C__case_27 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_27 x12 x13 x1 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> d_C_ppExpr x1 x13 cd cs
  Curry_Prelude.C_False -> d_C__case_26 x13 x12 x1 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x12 x13 x1 l
    cd cs) (d_C__case_27 x12 x13 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x12
    x13 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_27 x12 x13 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_27" [show x12, show x13, show x1, show
    x14] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_27" (showCons
    x14))

nd_C__case_27 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_27 x12 x13 x1 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppExpr x1 x13 s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_26 x13 x12 x1 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_27 x12 x13 x1 l
    s cd cs) (nd_C__case_27 x12 x13 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_27 x12
    x13 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_27 x12 x13 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_27" [show x12, show x13, show x1, show
    x14] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_27" (showCons
    x14))

d_C__case_26 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_26 x13 x12 x1 x14 cd cs = case x14 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_parensIf
    (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int 0#) cd cs))
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs) (Curry_Prelude.OP_Cons
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_OP_lt_plus_gt cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "let") cd cs) cd cs)
    (Curry_Pretty.d_C_encloseSep (Curry_Pretty.d_C_empty cd cs)
    (Curry_Pretty.d_C_empty cd cs) (Curry_Pretty.d_C_comma cd cs)
    (Curry_Prelude.d_C_map d_C_ppAVarIndex x12 cd cs) cd cs) cd cs) cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "free") cd cs) cd cs)
    (Curry_Prelude.OP_Cons (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_slash_gt cd cs) (Curry_Pretty.d_C_text
    (Curry_Prelude.toCurryString "in") cd cs) cd cs) (Curry_Prelude.d_C_apply
    (d_C_ppExp cd cs) x13 cd cs) cd cs) Curry_Prelude.OP_List)) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_26 x13 x12 x1 l
    cd cs) (d_C__case_26 x13 x12 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_26 x13
    x12 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_26 x13 x12 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_26" [show x13, show x12, show x1, show
    x14] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_26" (showCons
    x14))

nd_C__case_26 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_26 x13 x12 x1 x14 s cd cs = case x14 of
  Curry_Prelude.C_True -> let s42 = s
    in s42 `seq` (let s41 = leftSupply s42
                      s39 = rightSupply s42
    in s41 `seq` (s39 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    0#) cd cs))) (let s38 = leftSupply s39
                      s40 = rightSupply s39
                      s0 = leftSupply s40
                      s37 = rightSupply s40
    in s38 `seq` (s40 `seq` (s0 `seq` (s37 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s24 = leftSupply s37
                                          s35 = rightSupply s37
    in s24 `seq` (s35 `seq` Curry_Prelude.OP_Cons (let s23 = leftSupply s24
                                                       s25 = rightSupply s24
                                                       s20 = leftSupply s25
                                                       s22 = rightSupply s25
    in s23 `seq` (s25 `seq` (s20 `seq` (s22 `seq` Curry_Prelude.nd_C_apply
    (let s19 = leftSupply s20
         s21 = rightSupply s20
         s1 = leftSupply s21
         s17 = rightSupply s21
    in s19 `seq` (s21 `seq` (s1 `seq` (s17 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s1 cd cs) (let s16 = leftSupply s17
                                                  s18 = rightSupply s17
                                                  s5 = leftSupply s18
                                                  s12 = rightSupply s18
    in s16 `seq` (s18 `seq` (s5 `seq` (s12 `seq` Curry_Prelude.nd_C_apply
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s2 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s2 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "let") s3 cd cs) s4 cd cs))))
    (let s13 = leftSupply s12
         s14 = rightSupply s12
         s11 = leftSupply s13
         s7 = rightSupply s13
         s8 = leftSupply s14
         s15 = rightSupply s14
         s9 = leftSupply s15
         s10 = rightSupply s15
    in s13 `seq` (s14 `seq` (s11 `seq` (s7 `seq` (s8 `seq` (s15 `seq` (s9 `seq`
    (s10 `seq` Curry_Pretty.nd_C_encloseSep (Curry_Pretty.nd_C_empty s7 cd cs)
    (Curry_Pretty.nd_C_empty s8 cd cs) (Curry_Pretty.nd_C_comma s9 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id nd_C_ppAVarIndex) x12 s10 cd cs) s11 cd
    cs)))))))) s16 cd cs)))) s19 cd cs)))) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "free") s22 cd cs) s23 cd cs))))
    (Curry_Prelude.OP_Cons (let s34 = leftSupply s35
                                s36 = rightSupply s35
                                s29 = leftSupply s36
                                s33 = rightSupply s36
    in s34 `seq` (s36 `seq` (s29 `seq` (s33 `seq` Curry_Prelude.nd_C_apply
    (let s28 = leftSupply s29
         s30 = rightSupply s29
         s26 = leftSupply s30
         s27 = rightSupply s30
    in s28 `seq` (s30 `seq` (s26 `seq` (s27 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_slash_gt s26 cd cs) (Curry_Pretty.nd_C_text
    (Curry_Prelude.toCurryString "in") s27 cd cs) s28 cd cs))))
    (let s32 = leftSupply s33
         s31 = rightSupply s33
    in s32 `seq` (s31 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s31 cd cs) x13
    s32 cd cs)) s34 cd cs)))) Curry_Prelude.OP_List))) s38 cd cs)))) s41 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_26 x13 x12 x1 l
    s cd cs) (nd_C__case_26 x13 x12 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_26 x13
    x12 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_26 x13 x12 x1 e
    s cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_26" [show x13, show x12, show x1, show
    x14] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_26" (showCons
    x14))

d_C__case_29 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_29 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_equals cd cs) cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppExp cd cs) x4 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_28 x4 x3 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x3 x4 l cd cs)
    (d_C__case_29 x3 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x3
    x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_29 x3 x4 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_29" [show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_29" (showCons
    x5))

nd_C__case_29 :: forall t0 . (Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0)
  -> FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_29 x3 x4 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s9 = s
    in s9 `seq` (let s8 = leftSupply s9
                     s10 = rightSupply s9
                     s3 = leftSupply s10
                     s7 = rightSupply s10
    in s8 `seq` (s10 `seq` (s3 `seq` (s7 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (Curry_Pretty.nd_C_equals s1 cd cs)
    s2 cd cs)))) (let s6 = leftSupply s7
                      s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s5 cd cs) x4 s6
    cd cs)) s8 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_28 x4 x3 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_29 x3 x4 l s cd
    cs) (nd_C__case_29 x3 x4 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_29 x3
    x4 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_29 x3 x4 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_29" [show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_29" (showCons
    x5))

d_C__case_28 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Bool
  -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_28 x4 x3 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_slash_gt cd cs) (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_C_hsep cd cs) (Curry_Prelude.d_C_map d_C_ppAVarIndex x3 cd
    cs) cd cs) cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (Curry_Pretty.d_C_equals cd cs) cd cs)
    (Curry_Prelude.d_C_apply (d_C_ppExp cd cs) x4 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x4 x3 l cd cs)
    (d_C__case_28 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x4
    x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_28 x4 x3 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_28" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_28" (showCons
    x5))

nd_C__case_28 :: forall t0 . (Curry_Prelude.Curry
  t0) => FlatCurry.Annotated.Curry_Types.C_AExpr t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int t0) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_28 x4 x3 x5 s cd cs = case x5 of
  Curry_Prelude.C_True -> let s21 = s
    in s21 `seq` (let s20 = leftSupply s21
                      s22 = rightSupply s21
                      s7 = leftSupply s22
                      s18 = rightSupply s22
    in s20 `seq` (s22 `seq` (s7 `seq` (s18 `seq` Curry_Prelude.nd_C_apply
    (let s6 = leftSupply s7
         s8 = rightSupply s7
         s0 = leftSupply s8
         s4 = rightSupply s8
    in s6 `seq` (s8 `seq` (s0 `seq` (s4 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_slash_gt s0 cd cs) (let s3 = leftSupply s4
                                                   s5 = rightSupply s4
                                                   s1 = leftSupply s5
                                                   s2 = rightSupply s5
    in s3 `seq` (s5 `seq` (s1 `seq` (s2 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_hsep s1 cd cs) (Curry_Prelude.nd_C_map (wrapNX id
    nd_C_ppAVarIndex) x3 s2 cd cs) s3 cd cs)))) s6 cd cs))))
    (let s17 = leftSupply s18
         s19 = rightSupply s18
         s12 = leftSupply s19
         s16 = rightSupply s19
    in s17 `seq` (s19 `seq` (s12 `seq` (s16 `seq` Curry_Prelude.nd_C_apply
    (let s11 = leftSupply s12
         s13 = rightSupply s12
         s9 = leftSupply s13
         s10 = rightSupply s13
    in s11 `seq` (s13 `seq` (s9 `seq` (s10 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s9 cd cs) (Curry_Pretty.nd_C_equals s10 cd
    cs) s11 cd cs)))) (let s15 = leftSupply s16
                           s14 = rightSupply s16
    in s15 `seq` (s14 `seq` Curry_Prelude.nd_C_apply (nd_C_ppExp s14 cd cs) x4
    s15 cd cs)) s17 cd cs)))) s20 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_28 x4 x3 l s cd
    cs) (nd_C__case_28 x4 x3 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_28 x4
    x3 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_28 x4 x3 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_28" [show x4, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_28" (showCons
    x5))

d_C__case_30 :: Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_30 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_List
  Curry_Prelude.C_False -> Curry_Prelude.d_C_show x1 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x1 l cd cs)
    (d_C__case_30 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x1 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_30 x1 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_30" [show x1, show x2] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_30" (showCons
    x2))

d_C__case_33 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_33 x7 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_brackets cd
    cs) (Curry_Prelude.d_C_apply (d_C_ppTypeExp cd cs) (Curry_Prelude.d_C_head
    x7 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_32 x6 x7 x1 (d_C_isTupleId x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_33 x7 x6 x1 l cd
    cs) (d_C__case_33 x7 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_33 x7
    x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_33 x7 x6 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_33" [show x7, show x6, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_33" (showCons
    x8))

nd_C__case_33 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_33 x7 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_brackets s0 cd cs) (let s2 = leftSupply s3
                                               s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_ppTypeExp s1 cd cs)
    (Curry_Prelude.d_C_head x7 cd cs) s2 cd cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_32 x6 x7 x1 (d_C_isTupleId x6 cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_33 x7 x6 x1 l s
    cd cs) (nd_C__case_33 x7 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_33 x7
    x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_33 x7 x6 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_33" [show x7, show x6, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_33" (showCons
    x8))

d_C__case_32 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_32 x6 x7 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Pretty.d_C_tupled cd
    cs) (Curry_Prelude.d_C_map (d_C_ppTypeExp cd cs) x7 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_31 x7 x6 x1 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x6 x7 x1 l cd
    cs) (d_C__case_32 x6 x7 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x6
    x7 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_32 x6 x7 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_32" [show x6, show x7, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_32" (showCons
    x8))

nd_C__case_32 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_32 x6 x7 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s5 = s
    in s5 `seq` (let s4 = leftSupply s5
                     s6 = rightSupply s5
                     s0 = leftSupply s6
                     s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_tupled s0 cd cs) (let s2 = leftSupply s3
                                             s1 = rightSupply s3
    in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_map (nd_C_ppTypeExp s1 cd cs) x7 s2
    cd cs)) s4 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_31 x7 x6 x1 (Curry_Prelude.d_C_otherwise cd cs) s0 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_32 x6 x7 x1 l s
    cd cs) (nd_C__case_32 x6 x7 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_32 x6
    x7 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_32 x6 x7 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_32" [show x6, show x7, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_32" (showCons
    x8))

d_C__case_31 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_31 x7 x6 x1 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_dollar (Curry_Pretty.d_C_parensIf
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int
    1#) cd cs) (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x7 cd cs) cd cs)
    cd cs)) (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_sep cd cs)
    (Curry_Prelude.OP_Cons (d_C_ppPrefixOp x6 cd cs) (Curry_Prelude.d_C_map
    (d_C_ppTypeExpr (Curry_Prelude.C_Int 2#)) x7 cd cs)) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x7 x6 x1 l cd
    cs) (d_C__case_31 x7 x6 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x7
    x6 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_31 x7 x6 x1 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_31" [show x7, show x6, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_31" (showCons
    x8))

nd_C__case_31 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_TypeExpr
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_31 x7 x6 x1 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` Curry_Prelude.nd_OP_dollar (wrapNX id
    (Curry_Pretty.nd_C_parensIf (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_gt x1 (Curry_Prelude.C_Int 1#) cd cs)
    (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x7 cd cs) cd cs) cd cs)))
    (let s4 = leftSupply s5
         s6 = rightSupply s5
         s0 = leftSupply s6
         s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_sep s0 cd cs) (let s1 = leftSupply s3
                                          s2 = rightSupply s3
    in s1 `seq` (s2 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x6 s1 cd cs)
    (Curry_Prelude.nd_C_map (wrapNX id (nd_C_ppTypeExpr (Curry_Prelude.C_Int
    2#))) x7 s2 cd cs))) s4 cd cs)))) s7 cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_31 x7 x6 x1 l s
    cd cs) (nd_C__case_31 x7 x6 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_31 x7
    x6 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_31 x7 x6 x1 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_31" [show x7, show x6, show x1, show x8]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_31" (showCons
    x8))

d_C__case_34 :: Curry_Prelude.OP_List Curry_Pretty.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
d_C__case_34 x2 x3 x5 cd cs = case x5 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.OP_Cons (d_C_ppPrefixOp x3 cd
    cs) x2
  FlatCurry.Curry_Types.C_Private -> x2
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (d_C__case_34
    x2 x3 l cd cs) (d_C__case_34 x2 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_C__case_34 x2 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c (d_C__case_34
    x2 x3 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_34" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_34" (showCons
    x5))

nd_C__case_34 :: Curry_Prelude.OP_List Curry_Pretty.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Visibility -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
nd_C__case_34 x2 x3 x5 s cd cs = case x5 of
  FlatCurry.Curry_Types.C_Public -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x3 s0 cd cs) x2
  FlatCurry.Curry_Types.C_Private -> x2
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (nd_C__case_34
    x2 x3 l s cd cs) (nd_C__case_34 x2 x3 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    nd_C__case_34 x2 x3 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c (nd_C__case_34
    x2 x3 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_34" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_34" (showCons
    x5))

d_C__case_35 :: Curry_Prelude.OP_List Curry_Pretty.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Visibility -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
d_C__case_35 x2 x3 x5 cd cs = case x5 of
  FlatCurry.Curry_Types.C_Public -> Curry_Prelude.OP_Cons (d_C_ppPrefixOp x3 cd
    cs) x2
  FlatCurry.Curry_Types.C_Private -> x2
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (d_C__case_35
    x2 x3 l cd cs) (d_C__case_35 x2 x3 r cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    d_C__case_35 x2 x3 z cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c (d_C__case_35
    x2 x3 e cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_35" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_35" (showCons
    x5))

nd_C__case_35 :: Curry_Prelude.OP_List Curry_Pretty.C_Doc
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> FlatCurry.Curry_Types.C_Visibility -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Pretty.C_Doc
nd_C__case_35 x2 x3 x5 s cd cs = case x5 of
  FlatCurry.Curry_Types.C_Public -> let s0 = s
    in s0 `seq` Curry_Prelude.OP_Cons (nd_C_ppPrefixOp x3 s0 cd cs) x2
  FlatCurry.Curry_Types.C_Private -> x2
  FlatCurry.Curry_Types.Choice_C_Visibility d i l r -> narrow d i (nd_C__case_35
    x2 x3 l s cd cs) (nd_C__case_35 x2 x3 r s cd cs)
  FlatCurry.Curry_Types.Choices_C_Visibility d i xs -> narrows cs d i (\z ->
    nd_C__case_35 x2 x3 z s cd cs) xs
  FlatCurry.Curry_Types.Guard_C_Visibility d c e -> guardCons d c (nd_C__case_35
    x2 x3 e s cd $! addCs c cs)
  FlatCurry.Curry_Types.Fail_C_Visibility d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_35" [show x2, show x3, show x5] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_35" (showCons
    x5))

d_C__case_37 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_37 x7 x6 x8 cd cs = case x8 of
  Curry_Prelude.C_True -> Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_36 x6 (Curry_Prelude.d_C_otherwise cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x7 x6 l cd cs)
    (d_C__case_37 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x7
    x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_37 x7 x6 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_37" [show x7, show x6, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_37" (showCons
    x8))

nd_C__case_37 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_37 x7 x6 x8 s cd cs = case x8 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_36 x6 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_37 x7 x6 l s cd
    cs) (nd_C__case_37 x7 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_37 x7
    x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_37 x7 x6 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_37" [show x7, show x6, show x8] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_37" (showCons
    x8))

d_C__case_36 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_36 x6 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_ppPrefixOp x6 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x6 l cd cs)
    (d_C__case_36 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x6 z
    cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_36 x6 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_36" [show x6, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_36" (showCons
    x7))

nd_C__case_36 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
nd_C__case_36 x6 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_ppPrefixOp x6 s0 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_36 x6 l s cd cs)
    (nd_C__case_36 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_36 x6
    z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_36 x6 e s cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_36" [show x6, show x7] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_36" (showCons
    x7))

d_C__case_40 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Pretty.C_Doc
d_C__case_40 x3 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Pretty.d_C_empty cd cs
  Curry_Prelude.C_False -> d_C__case_39 x5 x2 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_all d_OP_ppTypeExport_dot_isPublicCons_dot_9 cd cs) x5 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_40 x3 x5 x2 l cd
    cs) (d_C__case_40 x3 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_40 x3
    x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_40 x3 x5 x2 e
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_40" [show x3, show x5, show x2, show x6]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_40" (showCons
    x6))

nd_C__case_40 :: FlatCurry.Curry_Types.C_Visibility -> Curry_Prelude.OP_List
  FlatCurry.Curry_Types.C_ConsDecl -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_40 x3 x5 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` Curry_Pretty.nd_C_empty s0 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_39 x5 x2 (let s1 = leftSupply s2
                                                   s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_all
    (wrapDX id d_OP_ppTypeExport_dot_isPublicCons_dot_9) s0 cd cs) x5 s1 cd cs))
    s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_40 x3 x5 x2 l s
    cd cs) (nd_C__case_40 x3 x5 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_40 x3
    x5 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_40 x3 x5 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_40" [show x3, show x5, show x2, show x6]
    info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_40" (showCons
    x6))

d_C__case_39 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_39 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixOp x2 cd cs) cd cs)
    (Curry_Pretty.d_C_text (Curry_Prelude.toCurryString "(..)") cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_38 x5 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x5 x2 l cd cs)
    (d_C__case_39 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_39 x5 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_39" [show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_39" (showCons
    x6))

nd_C__case_39 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_39 x5 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s7 = s
    in s7 `seq` (let s6 = leftSupply s7
                     s8 = rightSupply s7
                     s3 = leftSupply s8
                     s5 = rightSupply s8
    in s6 `seq` (s8 `seq` (s3 `seq` (s5 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (nd_C_ppPrefixOp x2 s1 cd cs) s2 cd
    cs)))) (Curry_Pretty.nd_C_text (Curry_Prelude.toCurryString "(..)") s5 cd
    cs) s6 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_38 x5 x2 (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_39 x5 x2 l s cd
    cs) (nd_C__case_39 x5 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_39 x5
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_39 x5 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_39" [show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_39" (showCons
    x6))

d_C__case_38 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Pretty.C_Doc
d_C__case_38 x5 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Pretty.d_OP_lt_plus_gt cd cs) (d_C_ppPrefixOp x2 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Pretty.d_C_tupled cd cs) (d_C_ppConsExports
    x5 cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x5 x2 l cd cs)
    (d_C__case_38 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x5
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (d_C__case_38 x5 x2 e cd $!
    addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_38" [show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_38" (showCons
    x6))

nd_C__case_38 :: Curry_Prelude.OP_List FlatCurry.Curry_Types.C_ConsDecl
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> Curry_Pretty.C_Doc
nd_C__case_38 x5 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_True -> let s11 = s
    in s11 `seq` (let s10 = leftSupply s11
                      s12 = rightSupply s11
                      s3 = leftSupply s12
                      s8 = rightSupply s12
    in s10 `seq` (s12 `seq` (s3 `seq` (s8 `seq` Curry_Prelude.nd_C_apply
    (let s2 = leftSupply s3
         s4 = rightSupply s3
         s0 = leftSupply s4
         s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_OP_lt_plus_gt s0 cd cs) (nd_C_ppPrefixOp x2 s1 cd cs) s2 cd
    cs)))) (let s7 = leftSupply s8
                s9 = rightSupply s8
                s5 = leftSupply s9
                s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` Curry_Prelude.nd_C_apply
    (Curry_Pretty.nd_C_tupled s5 cd cs) (nd_C_ppConsExports x5 s6 cd cs) s7 cd
    cs)))) s10 cd cs))))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_38 x5 x2 l s cd
    cs) (nd_C__case_38 x5 x2 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_38 x5
    x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c (nd_C__case_38 x5 x2 e s
    cd $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "FlatCurry.Annotated.Pretty._case_38" [show x5, show x2, show x6] info)
  _ -> failCons cd (consFail "FlatCurry.Annotated.Pretty._case_38" (showCons
    x6))

